program Create2Ddip
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use igrad2
  use solver_smp_mod
  use cgstep_mod
!!$  use dipinteg_3D
!!$  use igrad3_period 
!!$  use change_jl

  implicit none
  integer 	                             :: ix,iy,it,ir,ip,n1, n2, n3,stat1,bounds
  integer                                    :: taper_len,dist,sam_x,sam_y
  real                                       :: eps_j,pi_var
  real, dimension(:), allocatable :: data_1d, data_out,solv_out,cos_wt
  real, dimension (:,:),   allocatable  :: data_in,px,py,data_in_taper,subx_suby

  real, dimension (:,:),      allocatable::subx,suby
  complex, dimension (:,:),   allocatable  :: p_out


  call sep_init ()
  ! call from_history (n1,n2, esize = 4)
  call from_param("bounds",bounds,0)

  ! CREATE PI VARIABLE
  pi_var=dacos(-1)

  !call sep_read (data_in) 

  n1=20
  n2=20

  allocate (data_in (n1,n2))     
  data_in=0.
!!$data_in(1:5,1:5)=1.
!!$data_in(6:7,1:7)=2.
!!$data_in(1:7,6:7)=2.
!!$data_in(8:9,1:9)=3.
!!$data_in(1:9,8:9)=3.
!!$data_in(10:11,1:11)=4.
!!$data_in(1:11,10:11)=4.
!!$data_in(12:13,1:13)=5.
!!$data_in(1:13,12:13)=5.
!!$data_in(14:15,1:15)=6.
!!$data_in(1:15,14:15)=6.
  data_in=n1/2
  do ix=1,n1/2
     do iy=1,n2/2
         data_in(ix,iy)=max(ix,iy)
        data_in(n1-(ix-1),n2-(iy-1))=min(n1-(ix-1),n2-(iy-1))
     end do
  end do
!!$  do ix=n1/2+1,n1
!!$     do iy=n2/2+1,n2
!!$        !  data_in(ix,iy)=max(ix,iy)
!!$        !    data_in(ix,iy)=2*n1/2-.5*min(ix,iy)
!!$     end do
!!$  end do
  do ix=1,n1
     do iy=1,n2
     !   data_in(ix,iy)=data_in(ix,iy)+ix+iy
     end do
  end do


  select case(bounds)
  case(0)

  case(1) ! cosin taper

     n2=20
     n3=20
     taper_len=n2/5

     allocate(cos_wt(taper_len))
     do ir=0,taper_len-1
        cos_wt(ir+1)=dcos((pi_var/2)*(real(ir)/(taper_len-1)))
     end do
     allocate(data_in_taper(n2+2*taper_len,n3+2*taper_len))
     data_in_taper=0.
     data_in_taper(taper_len+1:taper_len+n2,taper_len+1:taper_len+n3)=data_in(:,:)
     ! deallocate(px)

     ! do it=1,n1
     do ix=1,n2+2*taper_len
        do iy=1,n3+2*taper_len
           if (ix<=taper_len.and.iy<=taper_len) then ! if in region 1
              dist=(max(abs(ix-(taper_len+1)),abs(iy-(taper_len+1))))
              data_in_taper( ix,iy)=data_in_taper( taper_len+1,taper_len+1)*cos_wt(dist)
           end if
           if (ix>taper_len.and.iy<=taper_len.and.ix<=n2+taper_len) then ! if in region 2
              dist=abs(taper_len+1-iy)
              data_in_taper( ix,iy)=data_in_taper( ix,taper_len+1)*cos_wt(dist)
           end if
           if (ix>n2+taper_len.and.iy<=taper_len) then ! if in region 3
              dist=(max(abs(ix-(n2+taper_len)),abs(iy-(taper_len+1))))
              data_in_taper( ix,iy)=data_in_taper( n2+taper_len,taper_len+1)*cos_wt(dist)
           end if
           if (ix>n2+taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 4
              dist=abs(n2+taper_len-ix)
              data_in_taper( ix,iy)=data_in_taper( taper_len+n2,iy)*cos_wt(dist)
           end if
           if (ix>n2+taper_len.and.iy>n3+taper_len) then ! if in region 5
              dist=(max(abs(ix-(n2+taper_len)),abs(iy-(n3+taper_len))))
              data_in_taper( ix,iy)=data_in_taper( taper_len+n2,taper_len+n3)*cos_wt(dist)
           end if
           if (ix>taper_len.and.iy>n3+taper_len.and.ix<=n2+taper_len) then ! if in region 6
              dist=abs((n3+taper_len-iy))
              data_in_taper( ix,iy)=data_in_taper( ix,taper_len+n3)*cos_wt(dist)
           end if
           if (ix<=taper_len.and.iy>n3+taper_len) then ! if in region 7
              dist=(max(abs(ix-(taper_len+1)),abs(iy-(n3+taper_len))))
              data_in_taper( ix,iy)=data_in_taper( taper_len+1,taper_len+n3)*cos_wt(dist)
           end if
           if (ix<=taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 8
              dist=abs(taper_len+1-ix)
              data_in_taper( ix,iy)=data_in_taper( taper_len+1,iy)*cos_wt(dist)
           end if


        end do
     end do
     !   end do

     n1=n1+2*taper_len
     n2=n2+2*taper_len


     deallocate(data_in)
     allocate(data_in(n1,n2))
     data_in=data_in_taper

  case(3) !micro-mirroring

     n2=20
     n3=20
     taper_len=n2/4
     sam_x=(n2-1)/taper_len
     sam_y=(n3-1)/taper_len
     !   allocate(cos_wt(taper_len))
     !do ir=0,taper_len-1
     !       cos_wt(ir+1)=dcos((pi_var/2)*(real(ir)/(taper_len-1)))
     !    end do
     allocate(data_in_taper(n2+2*taper_len,n3+2*taper_len))
     data_in_taper=0.
     data_in_taper(taper_len+1:taper_len+n2,taper_len+1:taper_len+n3)=data_in(:,:)
     ! deallocate(px)
     allocate(subx_suby(taper_len,taper_len),subx(taper_len,n2),suby(n1,taper_len))

     !subx_suby(taper_len,1)=data_in(n1,1)
     !subx_suby(taper_len,taper_len)=data_in(n1,n2)
     !subx_suby(1,taper_len)=data_in(1,n2)
     do ir=1,taper_len
        do ip=1,taper_len
      !     if (ir==1.and.ip==1) subx_suby(1,1)=data_in(1,1)
      !     if (ir==taper_len.and.ip==1) subx_suby(taper_len,1)=data_in(n1,1)
      !     if (ir==taper_len.and.ip==taper_len) subx_suby(taper_len,taper_len)=data_in(n1,n2)
      !     if (ir==1.and.ip==taper_len) subx_suby(1,taper_len)=data_in(1,n2)

           subx_suby(ir,ip)=data_in(1+sam_x*(ir-1),1+sam_y*(ip-1))
        end do
     end do
     !do ir=1,taper_len
     do ir=1,taper_len
        subx(ir,1:)=data_in(1+sam_x*(ir-1),1:)
     end do
     do ip=1,taper_len
        suby(1:,ip)=data_in(1:,1+sam_y*(ip-1))
     end do

     call to_history ("n1",   taper_len,"subx")
     call to_history ("n2",   n2,"subx")
     call to_history ("n3",   1,"subx")    
     call to_history ("esize",4,"subx")
     call sep_write (subx,"subx") 



     ! REGION 1
     data_in_taper(1:taper_len,1:taper_len)=subx_suby(taper_len:1:-1,taper_len:1:-1)

     ! REGION 2
     data_in_taper(taper_len+1:taper_len+n1,1:taper_len)=suby(1:n1,taper_len:1:-1)

     ! REGION 3
     data_in_taper(taper_len+n1+1:,1:taper_len)=subx_suby(taper_len:1:-1,taper_len:1:-1)

     ! REGION 4
     data_in_taper(taper_len+n1+1:,taper_len+1:taper_len+n2)=subx(taper_len:1:-1,1:n2)

     ! REGION 5
     data_in_taper(taper_len+n1+1:,taper_len+n2+1:)=subx_suby(taper_len:1:-1,taper_len:1:-1)

     ! REGION 6
     data_in_taper(taper_len+1:taper_len+n1,taper_len+n2+1:)=suby(1:n1,taper_len:1:-1)

     ! REGION 7
     data_in_taper(1:taper_len,taper_len+n2+1:)=subx_suby(taper_len:1:-1,taper_len:1:-1)

     ! REGION 8
     data_in_taper(1:taper_len,taper_len+1:taper_len+n2)=subx(taper_len:1:-1,1:n2)

     n1=n1+2*taper_len
     n2=n2+2*taper_len


     deallocate(data_in)
     allocate(data_in(n1,n2))
     data_in=data_in_taper


case(4) ! constant dip bounds


     n2=20
     n3=20
     taper_len=n2/5

     allocate(cos_wt(taper_len))
     do ir=0,taper_len-1
        cos_wt(ir+1)=dcos((pi_var/2)*(real(ir)/(taper_len-1)))
     end do
cos_wt=1.
     allocate(data_in_taper(n2+2*taper_len,n3+2*taper_len))
     data_in_taper=0.
     data_in_taper(taper_len+1:taper_len+n2,taper_len+1:taper_len+n3)=data_in(:,:)
     ! deallocate(px)

     ! do it=1,n1
     do ix=1,n2+2*taper_len
        do iy=1,n3+2*taper_len
           if (ix<=taper_len.and.iy<=taper_len) then ! if in region 1
              dist=(max(abs(ix-(taper_len+1)),abs(iy-(taper_len+1))))
              data_in_taper( ix,iy)=data_in_taper( taper_len+1,taper_len+1)*cos_wt(dist)
           end if
           if (ix>taper_len.and.iy<=taper_len.and.ix<=n2+taper_len) then ! if in region 2
              dist=abs(taper_len+1-iy)
              data_in_taper( ix,iy)=data_in_taper( ix,taper_len+1)*cos_wt(dist)
           end if
           if (ix>n2+taper_len.and.iy<=taper_len) then ! if in region 3
              dist=(max(abs(ix-(n2+taper_len)),abs(iy-(taper_len+1))))
              data_in_taper( ix,iy)=data_in_taper( n2+taper_len,taper_len+1)*cos_wt(dist)
           end if
           if (ix>n2+taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 4
              dist=abs(n2+taper_len-ix)
              data_in_taper( ix,iy)=data_in_taper( taper_len+n2,iy)*cos_wt(dist)
           end if
           if (ix>n2+taper_len.and.iy>n3+taper_len) then ! if in region 5
              dist=(max(abs(ix-(n2+taper_len)),abs(iy-(n3+taper_len))))
              data_in_taper( ix,iy)=data_in_taper( taper_len+n2,taper_len+n3)*cos_wt(dist)
           end if
           if (ix>taper_len.and.iy>n3+taper_len.and.ix<=n2+taper_len) then ! if in region 6
              dist=abs((n3+taper_len-iy))
              data_in_taper( ix,iy)=data_in_taper( ix,taper_len+n3)*cos_wt(dist)
           end if
           if (ix<=taper_len.and.iy>n3+taper_len) then ! if in region 7
              dist=(max(abs(ix-(taper_len+1)),abs(iy-(n3+taper_len))))
              data_in_taper( ix,iy)=data_in_taper( taper_len+1,taper_len+n3)*cos_wt(dist)
           end if
           if (ix<=taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 8
              dist=abs(taper_len+1-ix)
              data_in_taper( ix,iy)=data_in_taper( taper_len+1,iy)*cos_wt(dist)
           end if


        end do
     end do
     !   end do

     n1=n1+2*taper_len
     n2=n2+2*taper_len


     deallocate(data_in)
     allocate(data_in(n1,n2))
     data_in=data_in_taper

  
  end select












  allocate (px(n1,n2),py(n1,n2))

  px=0.
  py=0.

  do ix=1,n1-1
     do iy=1,n2-1
        px(ix,iy)=-data_in(ix,iy)+data_in(ix+1,iy)
        py(ix,iy)=-data_in(ix,iy)+data_in(ix,iy+1)

     end do
  end do
  px=0.
  py=0.
  allocate(data_1d(n1*n2),data_out(n1*n2*2))
  data_1d=reshape(data_in,(/size(data_in)/))
  call igrad2_init(n1,n2)

  stat1=igrad2_lop(.false.,.false.,data_1d , data_out) 
 
 py=reshape(data_out(1:n1*n2),(/n1,n2/))    
  px=reshape(data_out(n1*n2+1:n1*n2*2),(/n1,n2/))
!!$n1=n1-1
!!$n2=n2-1
deallocate(data_out)
allocate(p_out(n1,n2),data_out(n1*n2*2),solv_out(n1*n2)) 
 p_out=cmplx(py(1:n1,1:n2),px(1:n1,1:n2))
  data_out(1:n1*n2)=reshape(py,(/n1*n2/))
  data_out(n1*n2+1:2*n1*n2)=reshape(px,(/n1*n2/))
  call solver_smp(solv_out, data_out,igrad2_lop,cgstep,100,verb=.true.)
  call cgstep_close()

  write(0,*) 'size of data_in',size(data_in)
  call to_history ("n1",   1)
  call to_history ("n2",   n1)
  call to_history ("n3",   n2)    
  call to_history ("esize",8)
  call sep_write (p_out) 

!!$  call to_history ("n1",   n1,"data")
!!$  call to_history ("n2",   n2,"data")
!!$  call to_history ("n3",   1,"data")    
!!$  call to_history ("esize",4,"data")
!!$  call sep_write (data_in-sum(data_in)/(n1*n2),"data") 

!!$  call to_history ("n1",   n1,"test")
!!$  call to_history ("n2",   n2,"test")
!!$  call to_history ("n3",   1,"test")    
!!$  call to_history ("esize",4,"test")
!!$  call sep_write (solv_out-sum(solv_out)/(n1*n2),"test") 



  call sep_close()
  call exit (0)
end program Create2Ddip











