program Dipinteg_L1
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  ! use dipinteg_3D
  ! use dipinteg_precond
  ! use igrad3_period 
  ! use change_jl
  ! use fault_weight_cheap
  ! use igrad2
  use igrad3_epst
  use fault_weight
  use chain_mod
  ! use prec_oper
  ! use cgstep_jesse_mod
  ! use polydiv
  ! use lapfac
  ! use lapfac3
  ! use solver_prc_mod
  use igrad2_3d
  use cgstep_mod
  use solver_smp_mod
  ! use solver_smp_jesse_3D_mod

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,k,k_max,niter
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,stat1,stat2 
  integer                                    ::method,na
  real                                       :: q,eps_t,eps_h,pi_var,beta,alpha,epsi
  double precision     :: alpha_new,beta_new
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:),   allocatable    ::ztrans
  real,    dimension (:),     allocatable    :: cos_wt
  real,    dimension(:),pointer              ::rt,hh,Fop,ww,tmp1,tmp2,rt_adj,tmp3,rt_wt
  real,    dimension (:,:),   allocatable  ::hh_2D,r,z,p
  real,    dimension (:),   allocatable      ::s,BigR,BigS,g,BigG,init_m,tau,res
  real,    dimension (:),   allocatable      ::tau_grad
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,outwt
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3d
  !  complex, dimension (:,:,:),   allocatable    ::ztrans
  real,    dimension  (2)   :: dot1,dot2
  logical ::forget

  call sep_init ()
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("mirror",mirror,1)
  call from_param("bounds",bounds,1)
  call from_param("slice",slice,0)

  call from_param("method",method,1)
  call from_param("niter",niter,10)
  call from_aux ("dipx", n1,n2,n3,esize=4)
  allocate(px(n1,n2,n3),py(n1,n2,n3))


  allocate( rt( n1*n2*n3*3))

  call sep_read(px,"dipx")
  call sep_read(py,"dipy")

  rt=0.
  rt(n1*n2*n3+1  :n1*n2*n3*2)=reshape(px,(/size(px)/))
  rt(n1*n2*n3*2+1:n1*n2*n3*3)=reshape(py,(/size(px)/))
  deallocate(px,py)

  write(0,*) 'n1,n2,n3',n1,n2,n3

   call igrad3_epst_init(n1,n2,n3,eps_t)


  !     call z_trans(n1,2*n2,2*n3,eps_t,eps_h,ztrans)


  allocate(tau(n1*n2*n3),res(n1*n2*n3*3))
  allocate(tau_grad(n1*n2*n3*3),ww(n1*n2*n3*3))
ww=1.
  do it=1,1

     call fault_w_init(ww)

     call solver_smp(tau, rt,igrad3_epst_lop,cgstep,niter,verb=.true.,resd=res,Wop=fault_w_oper)


     call cgstep_close ()
     write(0,*) 'here1'
     ! stat1=igrad2_lop(.false.,.false.,tau,tau_grad)
     stat1=igrad3_epst_lop(.false.,.false.,tau,tau_grad)
     write(0,*) 'here2'
     res=tau_grad-rt

     ww=(1/(1+(res**2)/.1))**2 !ww=1/((1+res**2)**.5/1.)
     write(0,*) 'here3'

  end do

  call sep_write (tau) 
  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)

  call sep_write (res,"res") 
  call to_history ("n1",   n1,"res")
  call to_history ("n2",   n2,"res")
  call to_history ("n3",   n3*3,"res")    
  call to_history ("esize",4,"res")


  call sep_write (ww,"wt_out") 
  call to_history ("n1",   n1,"wt_out")
  call to_history ("n2",   n2,"wt_out")
  call to_history ("n3",   n3*3,"wt_out")    
  call to_history ("esize",4,"wt_out")


  call sep_close()
  call exit (0)






end program Dipinteg_L1











