program Dipintegrator  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use dipinteg
  use igrad2_period
  use igrad2


  implicit none
  integer 	                          :: n1, n2, n3, niter, iter, i1,i2,i3,mirror,diptest,stat1,dim2D
  real                                    :: q,avrhh
  complex, dimension (:,:),   allocatable :: data
  complex, dimension (:,:,:),   allocatable :: data_in 
  real,    dimension (:,:),   allocatable :: px_2D, py_2D,px_out,py_out,px_long, py_long
  real,    dimension (:,:),   allocatable :: hh_2D,hh_2D_trunc,test_plane,px_2D_mirr,py_2D_mirr
  real,    dimension (:),     allocatable :: hh,hhx,hhy,mat,mat_div,mat_grad, test_plane_1D,test_plane_grad_1D
  real,    dimension (:,:,:),   allocatable :: data_amp,data_phz,data_real,data_imag, px, py,test_plane_grad,data_out
  integer, dimension (:),     allocatable ::mati,mat_divi,mat_gradi
  call sep_init ()
  call from_history (n1,n2,n3, esize = 8)
  call to_history ("esize",4)


  write(0,*) n1,n2,n3
  call from_param("mirror",mirror,0)
  call from_param("diptest",diptest,0)
 call from_param("dim2D",dim2D,0)
  if (diptest==1) then
!     n2=66
!     n3=66
!     n1=10
     write(0,*) n1,n2,n3
  end if

 if (dim2D==1) then
     n3=n2
     n2=n1
     n1=1
     write(0,*) n1,n2,n3
  end if





  write(0,*) 'about to read in data'
  allocate (data_in (n1,n2,n3))                                   ! read data

if (diptest==0) then 
 call sep_read (data_in) ! ; data = data / maxval (cabs (data)) ! normalize
end if


  write(0,*) 'just before allocations'
  allocate (hhx(n2*n3),hhy(n2*n3),data(n2,n3),px(n1,n2,n3))
  allocate (py(n1,n2,n3),px_2D(n2,n3),py_2D(n2,n3),px_out(n1,n2*n3),py_out(n1,n2*n3))
  allocate (px_long(n2*2,n3*2),py_long(2*n2,2*n3),hh_2D(n2*2,n3*2),hh_2D_trunc(n2,n3))  
  allocate (test_plane(n2,n3),test_plane_1D(n2*n3),test_plane_grad(n2,n3,2),test_plane_grad_1D(n2*n3*2))
  allocate(px_2D_mirr(2*n2,2*n3),py_2D_mirr(2*n2,2*n3),hh(n2*n3*4),data_out(n1,n2,n3),hh_2D(2*n2,2*n3))

  write(0,*) 'just after allocations'

  px=real(data_in)  ! x direction dip
  py=aimag(data_in)  ! y direction dip


  allocate(mat(5*5),mat_grad(5*5*2),mat_div(5*5),mati(5*5),mat_gradi(5*5*2),mat_divi(5*5))
  !          1  2  3  4  5  6  7  1  2  3  4  5  6  7  1  2  3  4  5  6  7  1  2  3  4  5  6  7  1  2  3  4  5  6  7
  mat(1:5)  =(/0, 0, 1, 0, 0/)
  mat(6:10) =(/0, 0, 0, 0, 0/)
  mat(11:15)=(/1, 0, 0, 1, 0/)
  mat(16:20)=(/0, 0, 0, 0, 0/)
  mat(21:25)=(/0, 0, 0, 0, 1/)


  mat_grad=0.
  mat_div=0.
  call igrad2_period_init(5,5)
  stat1=igrad2_period_lop(.false.,.false.,mat , mat_grad)
  stat1=igrad2_period_lop(.true.,.false.,mat_div , mat_grad)
  mati=mat
  mat_divi=mat_div
  write(0,*) mati(1:5)
  write(0,*) mati(6:10)
  write(0,*) mati(11:15)
  write(0,*) mati(16:20)
  write(0,*) mati(21:25)
  write(0,*) ' space '
  write(0,*) mat_divi(1:5)
  write(0,*) mat_divi(6:10)
  write(0,*) mat_divi(11:15)
  write(0,*) mat_divi(16:20)
  write(0,*) mat_divi(21:25)










  Select Case (diptest)
  case(0)
     px=real(data_in)  ! x direction dip
     py=aimag(data_in)  ! y direction dip
     write(0,*) 'real data '
  case(1)

     !make a dipping reflector that is n2 * n3

     do i1=1,n2
	do i2=1,n3
           test_plane(i1,i2)=((i1-1)+(i2-1)) 
	end do
     end do
     test_plane_1D=reshape(test_plane,(/size(test_plane)/))
     call igrad2_init(n2,n3)        
     stat1=igrad2_lop(.false.,.false.,test_plane_1D , test_plane_grad_1D)

!     call igrad2_period_init(n2,n3)        
!     stat1=igrad2_period_lop(.false.,.false.,test_plane_1D , test_plane_grad_1D)
     test_plane_grad=reshape(test_plane_grad_1D,(/n2,n3,2/))

     do i1=1,n1
        px(i1,:,:)=test_plane_grad(:,:,1)
        py(i1,:,:)=test_plane_grad(:,:,2)
     end do
     !          call auxputch('n1','d',n2*2,'px.H')
     !          call auxputch('n2','d',n3*2,'hh.H')
     !          call auxputch('n3','d',1,'hh.H')
     !          call srite("hh.H",hh,4*n2*n3*4)

!!!!!!!!!!!!!!!!!!!!! test with all ones
!px=1.
!py=1.
write(0,*) ' set data to all ones'

  end select


 
  do i1=1,n1
     px_2D=px(i1,:,:)
     py_2D=py(i1,:,:)

!%%%%%%%%%%%%% make mirror
px_2D_mirr(1:n2,1:n3)     = px_2D(:,:);
px_2D_mirr(1:n2,n3+1:2*n3)  = px_2D(1:n2,n3:1:-1);
px_2D_mirr(n2+1:n2*2,1:2*n3)  = -1.*px_2D_mirr(n2:1:-1,1:2*n3);

py_2D_mirr(1:n2,1:n3)     = py_2D(:,:);
py_2D_mirr(n2+1:2*n2,1:n3)  = py_2D(n2:1:-1,1:n3);
py_2D_mirr(1:2*n2,n3+1:n3*2)  = -1.*py_2D_mirr(1:2*n2,n3:1:-1);
!               call auxputch('n1','d',n2,'mirror.H')
!               call auxputch('n2','d',n3,'mirror.H')
!               call auxputch('n3','d',1,'mirror.H')
!               call srite("mirror.H",py_2D,4*n2*n3)



     hh=0.
     write(0,*) 'size of px_2D/py_2D ', size(px_2D),size(py_2D),size(hh),n1,n2,n3
     write(0,*) 'starting dipintegrate sub-routine'
    call dipintegrate (px_2D_mirr,py_2D_mirr, hh)
   write(0,*) 'finished dipintegrate sub-routine'
    hh_2D=reshape(hh,(/2*n2,2*n3/))
     data_out(i1,:,:)=hh_2D(1:n2,1:n3)
     !write(0,*) i1,size(data_out),size(hh)

  end do

  !write(0,*) 'after loop'

  !write(0,*) data_out(50,:)
  write(0,*)'about to writeto history',n1,n2,n3
if (dim2D==1) then 
 call to_history ("n1",   n2)
  call to_history ("n2",   n3)
  call to_history ("n3",   n1)    
  call srite ("out",data_out, 4*n1*n2*n3) 
  write(0,*) 'wrote to history'
else
 call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call srite ("out",data_out, 4*n1*n2*n3) 
write(0,*) '2D output'
end if



  deallocate (data_out)
  call sep_close()
  call exit (0)
end program Dipintegrator













