program Dipintegrator_3D
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use dipinteg_3D
  use dipinteg_3D_slice
  use igrad3_period 
  use change_jl
  use dipinteg_precond_3D
  ! use ztrans_mod
  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len
  real                                       :: q,eps_t,eps_h,pi_var
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:),   allocatable    ::ztrans
  real,    dimension (:),     allocatable    :: cos_wt
  real,    dimension(:),pointer              ::rt,hh
  real,    dimension (:,:),   allocatable  ::hh_2D
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun

  call sep_init ()
  call from_history (n1,n2,n3, esize = 8)
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("mirror",mirror,1)
  call from_param("bounds",bounds,1)
  call from_param("slice",slice,0)



  select case(slice)
  case(0) ! 3D full volume integration
     allocate (data_in (n1,n2,n3))             
     call sep_read (data_in) 
     allocate (px(n1,n2,n3),py(n1,n2,n3))

     ! BREAK INPUT CUBE INTO X DIP DIRECTION AND Y DIP DIRECTIONS
     px=real(data_in)  ! x direction dip
     py=aimag(data_in)  ! y direction dip
     write(0,*) 'max px, min px, av',maxval(px),minval(px),sum(px)/(n1*n2*n3)
     write(0,*) 'max py, min py, av',maxval(py),minval(py),sum(py)/(n1*n2*n3)

     !  pz=1. ! set to 1's
     deallocate(data_in)

  case(1) ! 2D integration----1 time slice at a time
     allocate(data_in(n1,n2,1),px(n1,n2,1),py(n1,n2,1))
     bounds=4
  case(2)  ! 2D integration----1 2D vertical section at a time
     allocate(data_in(n1,n2,1),px(n1,n2,1),py(n1,n2,1))
     bounds=5
  end select






  ! CREATE PI VARIABLE
  pi_var=dacos(-1)


  ! write(0,*) 'about to make mirrors'
  ! MAKE MIRRORS

  ! allocate(pz_mirr(n1,n2*2,n3*2))
  ! pz_mirr=0.


  !  rt(1:n1*n2*2*n3*2)=reshape(pz_mirr,(/size(pz_mirr)/))
  !  deallocate(pz_mirr)

  select case(bounds)
  case(0)
     write(0,*) 'no input mirror'
     allocate( rt( n1*n2*n3*2))
     rt=0.
     rt(1:n1*n2*n3)=reshape(px,(/size(px)/))
     deallocate(px)
     rt(n1*n2*n3+1:2*n1*n2*n3)=reshape(py,(/size(py)/))
     deallocate(py)
!!$
     allocate(hh(n1*n2*n3))
!!$     write(0,*) 'made mirrors',n1,n2,n3
!!$ 
     ! CALL DIPINTEGRATOR
     write(0,*) 'max rt, min rt, av',maxval(rt),minval(rt),sum(rt)/(2*n1*n2*n3)
     !stop
     call dipintegrate_3D (rt,hh,eps_t,eps_h,n1,n2,n3)

!!$eps_t=1.
!!$eps_h=1.
!!$  allocate( rt( n1*n2*n3*3))
!!$     rt=0.
!!$     rt(n1*n2*n3:2*n1*n2*n3)=reshape(px,(/size(px)/))
!!$     deallocate(px)
!!$     rt(2*n1*n2*n3+1:3*n1*n2*n3)=reshape(py,(/size(py)/))
!!$     deallocate(py)
!!$     allocate( ztrans2(n1,2*n2,2*n3))
!!$  call z_trans2(n1,2*n2,2*n3,eps_t,eps_h,ztrans2)
!!$   call dipintegrate_precond_3D (rt,hh,eps_t,eps_h,n1,n2,n3,ztrans2) 


     write(0,*) 'reshaping to 3D',n1,n2,n3,minval(hh),maxval(hh)
!!$     ! RESHAPE TO 3D
!!$     allocate(hh_3D(n1,n2,n3))
!!$     hh_3D= reshape(hh,(/n1,n2,n3/))
!!$     deallocate(hh)
!!$     ! TRUNCATE OFF MIRROR
!!$     allocate(hh_3D_trun(n1,n2,n3))
!!$     hh_3D_trun=hh_3D
!!$     deallocate(hh_3D)
     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call sep_write (hh) 
     !
     call sep_close()
     call exit (0)


  case(1) ! mirror
     !  if (mirror) then
     allocate (px_mirr(n1,n2*2,n3*2))
     px_mirr(1:n1,1:n2,1:n3)       = px(:,:,:)
     px_mirr(1:n1,1:n2,n3+1:2*n3)  = px(1:n1,1:n2,n3:1:-1);
     px_mirr(1:n1,n2+1:n2*2,1:2*n3)= -1.*px_mirr(1:n1,n2:1:-1,1:2*n3);
     write(0,*) 'px',maxval(px),minval(px)
     deallocate(px)
     allocate( rt( n1*n2*2*n3*2*2))

     rt=0.
     rt(1:n1*n2*2*n3*2)=reshape(px_mirr,(/size(px_mirr)/))
     deallocate(px_mirr)

     allocate(py_mirr(n1,n2*2,n3*2))
     py_mirr(1:n1,1:n2,1:n3)       = py(:,:,:);
     py_mirr(1:n1,n2+1:2*n2,1:n3)  = py(1:n1,n2:1:-1,1:n3);
     py_mirr(1:n1,1:2*n2,n3+1:n3*2)= -1.*py_mirr(1:n1,1:2*n2,n3:1:-1);
     write(0,*) 'py',maxval(py),minval(py)
     deallocate(py)
     rt(n1*n2*2*n3*2+1:2*n1*n2*2*n3*2)=reshape(py_mirr,(/size(py_mirr)/))
     deallocate(py_mirr)
     write(0,*) 'rt1',maxval(rt(1:n1*n2*2*n3*2))
     write(0,*) 'rt1',maxval(rt(n1*n2*2*n3*2+1:2*n1*n2*2*n3*2))
     allocate(hh(n1*n2*n3*4))
     write(0,*) 'made mirrors',n1,n2,n3
     ! CALL DIPINTEGRATOR
     call dipintegrate_3D (rt,hh,eps_t,eps_h,n1,n2*2,n3*2)


     write(0,*) 'reshaping to 3D'
     ! RESHAPE TO 3D
     allocate(hh_3D(n1,2*n2,2*n3))
     hh_3D= reshape(hh,(/n1,2*n2,2*n3/))
     deallocate(hh)

     ! TRUNCATE OFF MIRROR
     allocate(hh_3D_trun(n1,n2,n3))
     hh_3D_trun=hh_3D(1:n1,1:n2,1:n3)
     deallocate(hh_3D)
  case(2) ! zero pad 4 samples on a side
     padlength=n2/5
     allocate(px_mirr(n1,n2+2*padlength,n3+2*padlength))
     px_mirr=0.
     px_mirr(1:n1,padlength+1:padlength+n2,padlength+1:padlength+n3)=px(:,:,:)
     deallocate(px)



     allocate( rt( n1*(n2+2*padlength)*(n3+2*padlength)*2))
     rt=0.
     rt(1:n1*(n2+2*padlength)*(n3+2*padlength))=reshape(px_mirr,(/size(px_mirr)/))
     !   deallocate(px_mirr)

     allocate(py_mirr(n1,n2+2*padlength,n3+2*padlength))
     py_mirr=0.
     py_mirr(1:n1,padlength+1:padlength+n2,padlength+1:padlength+n3) = py(:,:,:);
     deallocate(py)
     rt(n1*(n2+2*padlength)*(n3+2*padlength)+1:(n1*(n2+2*padlength)*(n3+2*padlength)*2))=reshape(py_mirr,(/size(py_mirr)/))


     call to_history ("n1",   n1,"junk")
     call to_history ("n2",   n2+2*padlength,"junk")
     call to_history ("n3",   n3+2*padlength,"junk")    
     call to_history ("esize",4,"junk")
     call sep_write (px_mirr,"junk") 
     write(0,*) 

!!$
!!$


     deallocate(py_mirr)

     allocate(hh(n1*(n2+2*padlength)*(n3+2*padlength)))
     write(0,*) 'made mirrors',n1,n2,n3
     ! CALL DIPINTEGRATOR
     call dipintegrate_3D (rt,hh,eps_t,eps_h,n1,n2+2*padlength,n3+2*padlength)


     write(0,*) 'reshaping to 3D'
     ! RESHAPE TO 3D
     allocate(hh_3D(n1,n2+2*padlength  ,n3+2*padlength))
     hh_3D= reshape(hh,(/n1,n2+2*padlength,n3+2*padlength/))
     deallocate(hh)

     ! TRUNCATE OFF MIRROR
     allocate(hh_3D_trun(n1,n2,n3))
     hh_3D_trun=hh_3D(1:n1,padlength+1:padlength+n2,padlength+1:padlength+n3)
     deallocate(hh_3D)
  case(3) ! cosin taper
     taper_len=6 !n2/5
     allocate(cos_wt(taper_len))
     do ir=0,taper_len-1
        cos_wt(ir+1)=dcos((pi_var/2)*(real(ir)/(taper_len-1)))
     end do
     allocate(px_mirr(n1,n2+2*taper_len,n3+2*taper_len),py_mirr(n1,n2+2*taper_len,n3+2*taper_len))
     px_mirr=0.
     py_mirr=0.
     px_mirr(1:n1,taper_len+1:taper_len+n2,taper_len+1:taper_len+n3)=px(:,:,:)
     py_mirr(1:n1,taper_len+1:taper_len+n2,taper_len+1:taper_len+n3)=py(:,:,:)
     deallocate(px)

!!$     do it=1,n1
!!$        do ix=1,n2
!!$           do iy=1,n3
!!$              if (ix<=taper_len.and.iy<=taper_len) then ! if in region 1
!!$                 dist=(max(abs(ix-(taper_len+1)),abs(iy-(taper_len+1))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+1,taper_len+1)*cos_wt(dist)
!!$              end if
!!$              if (ix>taper_len.and.iy<=taper_len.and.ix<=n2+taper_len) then ! if in region 2
!!$                 dist=abs(taper_len+1-iy)
!!$                 px_mirr(it,ix,iy)=px_mirr(it,ix,taper_len+1)*cos_wt(dist)
!!$              end if
!!$              if (ix>n2+taper_len.and.iy<=taper_len) then ! if in region 3
!!$                 dist=(max(abs(ix-(n2+taper_len)),abs(iy-(taper_len+1))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,n2+taper_len,taper_len+1)*cos_wt(dist)
!!$              end if
!!$              if (ix>n2+taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 4
!!$                 dist=abs(n2+taper_len-ix)
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+n2,iy)*cos_wt(dist)
!!$              end if
!!$              if (ix>n2+taper_len.and.iy>n3+taper_len) then ! if in region 5
!!$                 dist=(max(abs(ix-(n2+taper_len)),abs(iy-(n3+taper_len))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+n2,taper_len+n3)*cos_wt(dist)
!!$              end if
!!$              if (ix>taper_len.and.iy>n3+taper_len.and.ix<=n2+taper_len) then ! if in region 6
!!$                 dist=abs(n3+taper_len-iy)
!!$                 px_mirr(it,ix,iy)=px_mirr(it,ix,taper_len+n3)*cos_wt(dist)
!!$              end if
!!$              if (ix<=taper_len.and.iy>n3+taper_len) then ! if in region 7
!!$                 dist=(max(abs(ix-(taper_len+1)),abs(iy-(n3+taper_len))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+1,taper_len+n3)*cos_wt(dist)
!!$              end if
!!$              if (ix<=taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 8
!!$                 dist=(taper_len+1-ix)
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+1,iy)*cos_wt(dist)
!!$              end if
!!$
!!$
!!$           end do
!!$        end do
!!$     end do

     do it=1,n1
        do ix=1,n2+2*taper_len
           do iy=1,n3+2*taper_len
!!$              if (ix<=taper_len.and.iy<=taper_len) then ! if in region 1
!!$                 dist=(max(abs(ix-(taper_len+1)),abs(iy-(taper_len+1))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+1,taper_len+1)*cos_wt(dist)
!!$              end if
              if (ix>taper_len.and.iy<=taper_len.and.ix<=n2+taper_len) then ! if in region 2
                 dist=abs(taper_len+1-iy)
                 px_mirr(it,ix,iy)=px_mirr(it,ix,taper_len+1)*cos_wt(dist)
                 py_mirr(it,ix,iy)=py_mirr(it,ix,taper_len+1)*cos_wt(dist)
              end if
!!$              if (ix>n2+taper_len.and.iy<=taper_len) then ! if in region 3
!!$                 dist=(max(abs(ix-(n2+taper_len)),abs(iy-(taper_len+1))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,n2+taper_len,taper_len+1)*cos_wt(dist)
!!$              end if
!!$              if (ix>n2+taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 4
!!$                 dist=abs(n2+taper_len-ix)
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+n2,iy)*cos_wt(dist)
!!$              end if
!!$              if (ix>n2+taper_len.and.iy>n3+taper_len) then ! if in region 5
!!$                 dist=(max(abs(ix-(n2+taper_len)),abs(iy-(n3+taper_len))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+n2,taper_len+n3)*cos_wt(dist)
!!$              end if
              if (ix>taper_len.and.iy>n3+taper_len.and.ix<=n2+taper_len) then ! if in region 6
                 dist=abs(n3+taper_len-iy)
                 px_mirr(it,ix,iy)=px_mirr(it,ix,taper_len+n3)*cos_wt(dist)
                 py_mirr(it,ix,iy)=py_mirr(it,ix,taper_len+n3)*cos_wt(dist)
              end if
!!$              if (ix<=taper_len.and.iy>n3+taper_len) then ! if in region 7
!!$                 dist=(max(abs(ix-(taper_len+1)),abs(iy-(n3+taper_len))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+1,taper_len+n3)*cos_wt(dist)
!!$              end if
!!$              if (ix<=taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 8
!!$                 dist=(taper_len+1-ix)
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+1,iy)*cos_wt(dist)
!!$              end if


           end do
        end do
     end do
     do it=1,n1
        do ix=1,n2+2*taper_len
           do iy=1,n3+2*taper_len
!!$              if (ix<=taper_len.and.iy<=taper_len) then ! if in region 1
!!$                 dist=(max(abs(ix-(taper_len+1)),abs(iy-(taper_len+1))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+1,taper_len+1)*cos_wt(dist)
!!$              end if
!!$              if (ix>taper_len.and.iy<=taper_len.and.ix<=n2+taper_len) then ! if in region 2
!!$                 dist=abs(taper_len+1-iy)
!!$                 px_mirr(it,ix,iy)=px_mirr(it,ix,taper_len+1)*cos_wt(dist)
!!$              end if
!!$              if (ix>n2+taper_len.and.iy<=taper_len) then ! if in region 3
!!$                 dist=(max(abs(ix-(n2+taper_len)),abs(iy-(taper_len+1))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,n2+taper_len,taper_len+1)*cos_wt(dist)
!!$              end if
              if (ix>n2+taper_len) then ! if in region 4
                 dist=abs(n2+taper_len-ix)
                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+n2,iy)*cos_wt(dist)
                 py_mirr(it,ix,iy)=py_mirr(it,taper_len+n2,iy)*cos_wt(dist)
              end if
!!$              if (ix>n2+taper_len.and.iy>n3+taper_len) then ! if in region 5
!!$                 dist=(max(abs(ix-(n2+taper_len)),abs(iy-(n3+taper_len))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+n2,taper_len+n3)*cos_wt(dist)
!!$              end if
!!$              if (ix>taper_len.and.iy>n3+taper_len.and.ix<=n2+taper_len) then ! if in region 6
!!$                 dist=abs(n3+taper_len-iy)
!!$                 px_mirr(it,ix,iy)=px_mirr(it,ix,taper_len+n3)*cos_wt(dist)
!!$              end if
!!$              if (ix<=taper_len.and.iy>n3+taper_len) then ! if in region 7
!!$                 dist=(max(abs(ix-(taper_len+1)),abs(iy-(n3+taper_len))))
!!$                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+1,taper_len+n3)*cos_wt(dist)
!!$              end if
              if (ix<=taper_len) then ! if in region 8
                 dist=(taper_len+1-ix)
                 px_mirr(it,ix,iy)=px_mirr(it,taper_len+1,iy)*cos_wt(dist)
                 py_mirr(it,ix,iy)=py_mirr(it,taper_len+1,iy)*cos_wt(dist)
              end if


           end do
        end do
     end do
     allocate( rt( n1*(n2+2*taper_len)*(n3+2*taper_len)*2))
     rt=0.
     rt(1:n1*(n2+2*taper_len)*(n3+2*taper_len))=reshape(px_mirr,(/size(px_mirr)/))
     rt(n1*(n2+2*taper_len)*(n3+2*taper_len)+1:n1*(n2+2*taper_len)*(n3+2*taper_len)*2  )=reshape(py_mirr,(/size(py_mirr)/))
     !   deallocate(px_mirr)
     allocate(hh(n1*(n2+2*taper_len)*(n3+2*taper_len)))
     call dipintegrate_3D (rt,hh,eps_t,eps_h,n1,n2+2*taper_len,n3+2*taper_len)


     call to_history ("n1",   n2+2*taper_len,"junk")
     call to_history ("n2",   n3+2*taper_len,"junk")
     call to_history ("n3",   1,"junk")    
     call to_history ("esize",4,"junk")
     call sep_write (py_mirr,"junk")

     write(0,*) dcos(0),dcos(pi_var/2)

     allocate(hh_3D(n1,n2+2*taper_len  ,n3+2*taper_len))
     hh_3D= reshape(hh,(/n1,n2+2*taper_len,n3+2*taper_len/))
     deallocate(hh)

     ! TRUNCATE OFF MIRROR
     allocate(hh_3D_trun(n1,n2,n3))
     hh_3D_trun=hh_3D(1:n1,taper_len+1:taper_len+n2,taper_len+1:taper_len+n3)
     deallocate(hh_3D)
  case(4)  ! 2D integration----1 slice at a time

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
!!$
!!$     allocate(hh(n1*n2*4))
!!$     allocate(hh_2D(n1*2,n2*2))
     allocate(hh(n1*n2))
     allocate(hh_2D(n1,n2))

     allocate(px_mirr(1,n1*2,n2*2))
     allocate(py_mirr(1,n1*2,n2*2))
!!$     allocate( ztrans(2*n1-2,2*n2-2))
     allocate( ztrans(2*n1,2*n2))

     call z_trans(2*n1,2*n2,ztrans)
!!$call z_trans(2*n1-2,2*n2-2,ztrans)
     !write(0,*) 'z', ztrans,maxval(imag(ztrans)),minval(imag(ztrans))

     do it=1,n3
        ! allocate( rt( 1*n2*n3*2)) ! is deallocated within dipintegrate_3D subroutine
!!$        allocate( rt( n1*2*n2*2*2))
        allocate( rt( n1*n2*2))

        call sep_read (data_in)

!!$   call to_history ("n1",   n1,"tester")
!!$  call to_history ("n2",   n2,"tester")
!!$  call to_history ("n3",   1 ,"tester")    
!!$  call to_history ("esize",8,"tester")
!!$  call sep_write (data_in,"tester") 
!!$stop
        ! BREAK INPUT CUBE INTO X DIP DIRECTION AND Y DIP DIRECTIONS
        px=real(data_in)  ! x direction dip

        py=aimag(data_in)  ! y direction dip
        !write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.

!!$        px_mirr(1,1:n1,1:n2)       = px(:,:,1)
!!$        px_mirr(1,1:n1,n2+1:2*n2)  = px(1:n1,n2:1:-1,1)
!!$        px_mirr(1,n1+1:n1*2,1:2*n2)= -1.*px_mirr(1,n1:1:-1,1:2*n2);
!!$        rt(1:1*n1*2*n2*2)=reshape(px_mirr,(/size(px_mirr)/))
!!$        py_mirr(1,1:n1,1:n2)       = py(:,:,1)
!!$        py_mirr(1,n1+1:2*n1,1:n2)  = py(n1:1:-1,1:n2,1);
!!$        py_mirr(1,1:2*n1,n2+1:n2*2)= -1.*py_mirr(1,1:2*n1,n2:1:-1);
!!$        rt(n1*2*n2*2+1:2*n1*2*n2*2)=reshape(py_mirr,(/size(py_mirr)/))
        rt(1:n1*n2)=reshape(px,(/size(px)/))
        rt(n1*n2+1:2*n1*n2)=reshape(py,(/size(py)/))


        !eps_t=0.
        ! write(0,*) 'made mirrors',n1,n2,n3
        ! CALL DIPINTEGRATOR
        !        write(0,*) 'about to integrate'
!!$        call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1*2,n2*2,ztrans)
        call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)
        !       write(0,*) 'integrated'
        ! write(0,*) 'reshaping to 3D',n1,n2,n3,minval(hh),maxval(hh)
        ! RESHAPE TO 3D
        !      write(0,*) 'hh',maxval(hh),minval(hh),sum(hh)/size(hh)
        ! hh_3D=reshape(hh,(/1,n2,n3/))

!!$        hh_2D=reshape(hh,(/n1*2,n2*2/))
        hh_2D=reshape(hh,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
        ! call sep_write (hh_2D(1:n1,1:n2)-hh_2D(n1/2,n2/2))
        write(0,*) 'finished slice',it,' of ',n3
     end do
     call sep_close()
     call exit (0)

  end select

  write(0,*) 'reshaping to 3D',n1,n2,n3,minval(hh_3D_trun),maxval(hh_3D_trun)
  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)
  call sep_write (hh_3D_trun-sum(hh_3D_trun)/(n1*n2*n3)) 




  deallocate (hh_3D_trun)
  call sep_close()
  call exit (0)
end program Dipintegrator_3D











