program Dipintegrator_TX_wt_reg

  use sep
  use cgstep_mod
  use solver_smp_mod
  use solver_reg_mod
  use solver_prc_mod
  use igrad1
  use igrad2
  use fault_weight
  use dottest
  use igrad3
  use igrad3_period
  use igrad1_3d
  use igrad2_3d
  use triangle3
  use flat_mod
  use igrad2
  use polydiv
  use leakint3
  use polydiv3D


  implicit none


  integer 	                          :: n1, n2, n3,iter,it,i1,i2,i3,usewt,boxsz,stat1,i1min,i1max,i2min,i2max,i3min,i3max
  complex, dimension (:,:,:),   allocatable :: data_in
  real, dimension (:,:,:),      allocatable ::px_3D,py_3D,t_m_3D_long, ww_3D,px_mirr,py_mirr,pz_mirr,outwt,norm_wt,outwt_sm,outwt_raw, outwt_sm_3d
  real,    dimension (:),     allocatable ::p,t_m,t_m0,p_s,outwt_1D,outwt_sm_1D,t_m_long,p_0,rescube
  real,    dimension (:),    pointer      :: ww,aa1    ! ,testvol,testvolout
  real, dimension (:,:,:),      allocatable ::out,t_m_3D,p_0_3D !,testvol_3D
  real,    dimension  (2)   :: dot1,dot2    
  real                      ::d1,d2,d3,o1,o2,o3,eps,maxdat,mindat,rangedat,wt_bclip
  type( filter)                       :: aa
  call sep_init ()

  call from_history (n1,n2,n3,esize = 8)
  call from_history ("d1",d1,1.) ; call from_history ("o1",o1,0.)
  call from_history ("d2",d2,1.) ; call from_history ("o2",o2,0.)
  call from_history ("d3",d3,1.) ; call from_history ("o3",o3,0.)

  call to_history ("d1",d1) ; call to_history ("o1",o1)
  call to_history ("d2",d2) ; call to_history ("o2",o2)
  call to_history ("d3",d3) ; call to_history ("o3",o3)


  write(0,*) 'n1,n2,n3',n1,n2,n3 
  allocate (data_in(n1,n2,n3),px_3D(n1,n2,n3),py_3D(n1,n2,n3))
  allocate(p((n1)*(n2)*(n3)*2 ),t_m((n1)*(n2)*(n3))) !,t_m_3D(n1,n2,n3),p_0_3D(n1,n2,n3))
  allocate(ww((n1)*(n2)*(n3)*2),rescube(n1*n2*n3*2))!ww_3D(n1,n2,n3),
  allocate(outwt(n1,n2,n3)) !,norm_wt(n1,n2,n3),outwt_sm(n1,n2,n3))! ,outwt_1D(n1*n2*n3))!,outwt_sm_1D(n1*n2*n3)) !,outwt_raw(n1,n2,n3), outwt_sm_3d(n1,n2,n3) ) 

  call sep_read (data_in)
  call from_param("boxsz",boxsz,0);
  call from_param("iter",iter,100);
  call from_param("usewt",usewt,0);
  call from_param("eps",eps,0.);
  call from_param("wt_bclip",wt_bclip,.85) ! lower clip after weight is normalized
  if (usewt==0.) then
     outwt=1.
  else 
     call sreed("wt", outwt,4*n1*n2*n3)
     write(0,*) 'min of outwt', minval(outwt),maxval(outwt), sum(outwt)/size(outwt)
  endif

  write(0,*)'d1,d2,d3',d1,d2,d3

  px_3D=real(data_in)!*(d1/d2)  ! x direction dip
  py_3D=aimag(data_in)!*(d1/d3)  ! y direction dip
  write(0,*) 'min/max/avg(px)',minval(px_3D),maxval(px_3D),sum(px_3D)/size(px_3D)
  write(0,*) 'min/max/avg(py)',minval(py_3D),maxval(py_3D),sum(py_3D)/size(py_3D)


  deallocate(data_in)


  write(0,*) 'n1,n2,n3',n1,n2,n3, size(data_in),size(px_3D)


  !normalize the weight 
  maxdat=maxval(outwt);
  mindat=minval(outwt);
  rangedat=maxdat-mindat;
  if (rangedat/=0.) then   !just in case the weights are all the same
     outwt=outwt/rangedat-mindat/rangedat
     !outwt=norm_wt
  end if
  !  deallocate(norm_wt)
  !  outwt_sm=outwt
  !deallocate(out_wt)
  !loop thru smoothed weight and clip to one
  do i1=1,n1
     do i2=1,n2
        do i3=1,n3
           if (outwt(i1,i2,i3).GE.wt_bclip) then
              !     outwt(i1,i2,i3)=1.
           else
              !    outwt(i1,i2,i3)=0.
           end if
        end do
     end do
  end do
  ! deallocate(outwt) 
  ! end if

!!$  ww_3D=1.
!!$
!!$  ww_3D=outwt   !*outwt_raw
  write(0,*) 'min/max/avg(outwt)',minval(outwt),maxval(outwt),sum(outwt)/size(outwt)

  ! ww_3D_long(1:n1,1:n2,1:n3)=ww_3D
  !deallocate(ww_3D)
ww=0.
  ww(1:(n1)*(n2)*(n3))=reshape(outwt,(/(n1)*(n2)*(n3)/))
  ww((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2)=reshape(outwt,(/(n1)*(n2)*(n3)/))
 ! deallocate(ww_3D)
!!$ call to_history("n1",n1,"ww"); call to_history("n2",n2,"ww")
!!$  call to_history("n3",n3*2,"ww")
!!$  call to_history("d1",d1,"ww"); call to_history("d2",d2,"ww")
!!$  call to_history("d3",d3,"ww")
!!$  call to_history("o1",o1,"ww"); call to_history("o2",o3,"ww")
!!$  call to_history("o3",o3,"ww")
!!$  call to_history("esize",4,"ww")
!!$  call sep_write(ww,"ww")	

!!$  px_3D_long=0.
!!$  py_3D_long=0.
!!$  px_3D_long(1:n1,1:n2,1:n3)=px_3D
!!$  py_3D_long(1:n1,1:n2,1:n3)=py_3D
  p=1.
  ! p(1             :n1*n2*n3  )= 1.

  p(1               :(n1)*(n2)*(n3))  = reshape(px_3D,(/(n1)*(n2)*(n3)/))
  p((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2)= reshape(py_3D,(/(n1)*(n2)*(n3)/))
  ! delete me
!!$  p(1                   :   (n1+1)*(n2)*(n3)        )= reshape(px_3D_long,(/(n1+1)*(n2)*(n3)/))
!!$  p((n1+1)*(n2)*(n3)+1  :   (n1+1)*(n2)*(n3)*2      )= reshape(py_3D_long,(/(n1+1)*(n2)*(n3)/))


  deallocate(px_3D,py_3D)
  write(0,*) 'min/max/avg(p)',minval(p),maxval(p),sum(p)/size(p)
  write(0,*) 'min/max/avg(p)',minval(p(1:(n1)*(n2)*(n3))),maxval(p(1:(n1)*(n2)*(n3))),sum(p(1:(n1)*(n2)*(n3)))/size(p(1:(n1)*(n2)*(n3)))
  write(0,*) 'n1,n2,n3',n1,n2,n3



  write(0,*) 'min/max/avg(p)',minval(p((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2)),maxval(p((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2)),sum(p((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2))/size(p((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2))
  !stop
  call igrad1_3d_init(n1,n2,n3)
  call igrad2_3d_init(n1,n2,n3)
  call igrad2_init(n2,n3)

  write(0,*) 'min/max/avg(ww)',minval(ww),maxval(ww),sum(ww)/size(ww)

  write(0,*) 'init fault weight'
  call fault_w_init(ww)
  write(0,*) 'after init fault weight'
  ! call dot_test (fault_w_oper,n1*n2,n1*n2,dot1,dot2)
  write(0,*) 'after 1st dottest'
  ! call dot_test (igrad1_3d_lop,(n1)*(n2)*(n3),(n1)*(n2)*(n3),dot1,dot2)
  write(0,*) 'after 2nd dottest'
  !  call dot_test (igrad2_3d_lop,(n1)*(n2)*(n3),(n1)*(n2)*(n3)*2,dot1,dot2)
  write(0,*) 'after dottest'
  !stat1=igrad2_3d_lop(.false.,.false.,testvol, testvolout)
  !write(0,*) testvolout
  ! call solver_smp(t_m, p,igrad3_period_lop,cgstep,iter,verb=.true.,Wop=fault_w_oper)

  !	   call polydiv_init(m1*m2,peff)


  call leakint3_init(n1,n2,n3,.95)
  write(0,*) 'before solver'
  t_m=0.
  if (exist_file("init_sol")) then
     write(0,*) 'file exists' 
     allocate(t_m0((n1)*(n2)*(n3)))
     call sreed("init_sol", t_m0,4*n1*n2*n3)

     !t_m_3D=reshape(t_m,(/n1,n2,n3/))
     !    allocate(p_0(2*(n1)*(n2)*(n3)))
     !stat1=leakint3_lop(.false.,.false.,t_m,p_0) ! interesting result 
     !  stat1=igrad1_3D_lop(.false.,.false.,t_m0,p_0) 
     !stat1=igrad2_3D_lop(.false.,.false.,t_m0,p_0) 
     !t_m=0.
     !p=p-p_0
     !p_0=reshape(p_0_3D,(size(p_0)))
  end if
  write(0,*) 'eps',eps
  !eps=0.
  !  call dot_test (leakint3_lop,n1*n2*n3,n1*n2*n3,dot1,dot2)
  write(0,*) 't_m0',maxval(t_m0),minval(t_m0)
!  call solver_reg(t_m, p,igrad2_3D_lop,igrad1_3D_lop,cgstep,(n1)*(n2)*(n3),iter,eps,verb=.true.,m0=t_m0,Wop=fault_w_oper,resd=rescube)!,m0=t_m)
  call solver_reg(t_m, p,igrad2_3D_lop,igrad1_3D_lop,cgstep,(n1)*(n2)*(n3),iter,eps,verb=.true.,Wop=fault_w_oper,resd=rescube,m0=t_m0)

  !t_m=0.
!!$  call allocatehelix( aa, 1) 
!!$  allocate(aa1(2))
!!$  aa1(1)=-1.
!!$  aa1(2)=.8 !969   
!!$  aa%flt = 0.
!!$  aa%lag = (/ 1 /)	
!!$  aa%flt = -.969
  !  call polydiv3D_init(n1,n2,n3,aa1)
  !call polydiv1_init(aa1)
  !  call dot_test (polydiv3D_lop,n1*n2*n3,n1*n2*n3,dot1,dot2)
  !  call solver_prc(t_m, p,igrad2_3D_lop,leakint3_lop,cgstep,(n1)*(n2)*(n3),iter,eps,verb=.true.)
  ! call solver_prc(t_m, p,igrad2_3D_lop,polydiv3D_lop,cgstep,(n1)*(n2)*(n3),iter,eps,verb=.true.)
  !  call solver_smp(t_m, p,igrad2_3D_lop,cgstep,10,verb=.true.)




  !t_m=t_m +t_m0

  ! call solver_smp(t_m, p,igrad2_lop,cgstep,iter,verb=.true.)
  call cgstep_close()
  deallocate(p,ww)
  write(0,*) 'after solver'
!!$allocate(t_m_3D_long(n1,n2,n3))
!!$  t_m_3D_long=reshape(t_m_long,(/n1,n2,n3/))
!!$deallocate(t_m_long)
!!$allocate(t_m_3D(n1,n2,n3))
!!$  t_m_3D=t_m_3D_long(1:n1,1:n2,1:n3)  !need to cut the last sample off in each dimension because of the gradient ...could pad out the data instead
!!$deallocate(t_m_3D_long)
!!$  ! 
!!$allocate(t_m(n1*n2*n3))
!!$
!!$  t_m=0.
!!$  t_m=reshape(t_m_3D,(/n1*n2*n3/))
!!$deallocate(t_m_3D)
  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)


  call srite("out" ,t_m  , n1*n2*n3*4)

stat1=igrad2_3D_lop(.true.,.false.,t_m,rescube)

  call to_history("n1",n1,"wtout"); call to_history("n2",n2,"wtout")
  call to_history("n3",n3,"wtout")
  call to_history("d1",d1,"wtout"); call to_history("d2",d2,"wtout")
  call to_history("d3",d3,"wtout")
  call to_history("o1",o1,"wtout"); call to_history("o2",o3,"wtout")
  call to_history("o3",o3,"wtout")
  call to_history("esize",4,"wtout")
  call sep_write(outwt,"wtout")	


  call to_history("n1",n1,"res"); call to_history("n2",n2,"res")
  call to_history("n3",n3*2,"res")
  call to_history("d1",d1,"res"); call to_history("d2",d2,"res")
  call to_history("d3",d3,"res")
  call to_history("o1",o1,"res"); call to_history("o2",o3,"res")
  call to_history("o3",o3,"res")
  call to_history("esize",4,"res")
  call sep_write(rescube,"res")	


  call to_history("n1",n1,"div"); call to_history("n2",n2,"div")
  call to_history("n3",n3,"div")
  call to_history("d1",d1,"div"); call to_history("d2",d2,"div")
  call to_history("d3",d3,"div")
  call to_history("o1",o1,"div"); call to_history("o2",o3,"div")
  call to_history("o3",o3,"div")
  call to_history("esize",4,"div")
  call sep_write(t_m,"div")	

  call sep_close()


  call exit (0)
end program Dipintegrator_TX_wt_reg
