program Dipintegrator_slice
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use dipinteg_3D
  use igrad3_period 
  use change_jl

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror
  real                                       :: q,eps_t,eps_h
  complex, dimension (:,:,:),   allocatable  :: data_in
  real,    dimension (:),     allocatable    :: hh
  real,    dimension(:),pointer              ::rt
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun

  call sep_init ()
  call from_history (n1,n2,n3, esize = 8)
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("mirror",mirror,1)
  allocate (data_in (n1,n2,n3))             
  call sep_read (data_in) 

  allocate (px(n1,n2,n3),py(n1,n2,n3))

  ! BREAK INPUT CUBE INTO X DIP DIRECTION AND Y DIP DIRECTIONS
  px=real(data_in)  ! x direction dip
  py=aimag(data_in)  ! y direction dip
  !  pz=1. ! set to 1's
  deallocate(data_in)

  write(0,*) 'about to make mirrors'
  ! MAKE MIRRORS

  ! allocate(pz_mirr(n1,n2*2,n3*2))
  ! pz_mirr=0.


  !  rt(1:n1*n2*2*n3*2)=reshape(pz_mirr,(/size(pz_mirr)/))
  !  deallocate(pz_mirr)
  if (mirror) then
     allocate (px_mirr(n1,n2*2,n3*2))
     px_mirr(1:n1,1:n2,1:n3)       = px(:,:,:)
     px_mirr(1:n1,1:n2,n3+1:2*n3)  = px(1:n1,1:n2,n3:1:-1);
     px_mirr(1:n1,n2+1:n2*2,1:2*n3)= -1.*px_mirr(1:n1,n2:1:-1,1:2*n3);
     deallocate(px)
     allocate( rt( n1*n2*2*n3*2*2))
     rt=0.
     rt(1:n1*n2*2*n3*2)=reshape(px_mirr,(/size(px_mirr)/))
     deallocate(px_mirr)

     allocate(py_mirr(n1,n2*2,n3*2))
     py_mirr(1:n1,1:n2,1:n3)       = py(:,:,:);
     py_mirr(1:n1,n2+1:2*n2,1:n3)  = py(1:n1,n2:1:-1,1:n3);
     py_mirr(1:n1,1:2*n2,n3+1:n3*2)= -1.*py_mirr(1:n1,1:2*n2,n3:1:-1);
     deallocate(py)
     rt(n1*n2*2*n3*2+1:2*n1*n2*2*n3*2)=reshape(py_mirr,(/size(py_mirr)/))
     deallocate(py_mirr)

     allocate(hh(n1*n2*n3*4))
     write(0,*) 'made mirrors',n1,n2,n3
     ! CALL DIPINTEGRATOR
     call dipintegrate_3D (rt,hh,eps_t,eps_h,n1,n2*2,n3*2)


     write(0,*) 'reshaping to 3D'
     ! RESHAPE TO 3D
     allocate(hh_3D(n1,2*n2,2*n3))
     hh_3D= reshape(hh,(/n1,2*n2,2*n3/))
     deallocate(hh)

     ! TRUNCATE OFF MIRROR
     allocate(hh_3D_trun(n1,n2,n3))
     hh_3D_trun=hh_3D(1:n1,1:n2,1:n3)
     deallocate(hh_3D)
  else 
     allocate( rt( n1*n2*n3*2))
     rt=0.
     rt(1:n1*n2*n3)=reshape(px,(/size(px)/))
     deallocate(px)
     rt(n1*n2*n3+1:2*n1*n2*n3)=reshape(py,(/size(py)/))
     deallocate(py)

     allocate(hh(n1*n2*n3))
     write(0,*) 'made mirrors',n1,n2,n3
     ! CALL DIPINTEGRATOR
     call dipintegrate_3D (rt,hh,eps_t,eps_h,n1,n2,n3)
     write(0,*) 'reshaping to 3D'
     ! RESHAPE TO 3D
     allocate(hh_3D(n1,n2,n3))
     hh_3D= reshape(hh,(/n1,n2,n3/))
     deallocate(hh)
     ! TRUNCATE OFF MIRROR
     allocate(hh_3D_trun(n1,n2,n3))
     hh_3D_trun=hh_3D
     deallocate(hh_3D)
  end if
  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)
  call sep_write (hh_3D_trun) 



  deallocate (hh_3D_trun)
  call sep_close()
  call exit (0)
end program Dipintegrator_slice











