program Flatten_big  !
  ! flatten a big cube one 2D slice at a time
  !
  use sep
  use lint1
  use lint1_jesse
  use sorting_mod

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,it,data_out_index,subsam, shift_floor, shift_ceil, useinwt,n1_long,min_shift,counter
  integer ::mm_min, mm_max, mm_sz,n1_aux,n1_out,ref_2,ref_3
  integer :: is_allocate
  real :: d1,d2,d3,o1,o2,o3,o1_aux
  real,   dimension(:,:), target    :: shifted_outputs
  real,   dimension(:), target    :: ref_trace
  real,    dimension (:,:,:),   allocatable :: data_in,time_cube,outwt,inwt
  real,    dimension (:,:),   allocatable ::time_shift_panel,data_panel,shift_panel,data_out
  real, save, pointer, dimension(:)         ::lint_in, lint_out,shift_vec,shifted_test
  real,dimension(:)         ::mm_interp
  real, save, dimension(:),pointer                        ::coord
  real                                      ::shift_var,iprl, diffrl,shift_diff,upwt,dwnwt,max_move,min_move,range_move
  logical :: flatten
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call from_aux("aux",n1_aux)  
  call from_aux("aux","o1",o1_aux)  
  !write(0,*) 'n1_aux',n1_aux
  !write(0,*) 'o1_aux',o1_aux
  !stop
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0)
  call from_param("subsample",subsam,1)
  call from_param("flatten",flatten,.true.)
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  write(0,*) 'ref_2/ref_3 coordinates of reference trace',ref_2,ref_3

  call from_history ("d1",d1,1.) ; call from_history ("o1",o1,0.)
  call from_history ("d2",d2,1.) ; call from_history ("o2",o2,0.)
  call from_history ("d3",d3,1.) ; call from_history ("o3",o3,0.)







  write(0,*) 'n1/n2/n3',n1,n2,n3


  !compute range in order to preserve data
  it=0  

  ! READ IN REFERECENCE TRACE
  allocate(ref_trace(n1),time_shift_panel(n1,n2),shift_panel(n1,n2))
  allocate(shifted_outputs(2,n1_aux))
  call sreed("ref",ref_trace,4*n1_aux)

  ! READ IN DATASET ONE 2D SECTION AT A TIME TO KNOW MAX AND MIN
  do i3=1,n3
     call sreed("aux", time_shift_panel,4*n1_aux*n2)
     do i2=1,n2
        do i1=1,n1_aux
           it=it+1
           shift_panel(i1,i2)=(i1-(time_shift_panel(i1,i2)-ref_trace(i1)))
           !   write(0,*) 'shift_panel',shift_panel(i1,i2)
        end do
     end do
     if (i3==1) then
        max_move=maxval(shift_panel)
        min_move=minval(shift_panel) 
     else
        max_move=max(maxval(shift_panel),max_move)
        min_move=min(minval(shift_panel),min_move) 
     end if
     write(0,*) 'panel ',i3,'of ',n3 !,max_move,min_move,subsam
  end do

  min_shift=floor(min_move)
  range_move=abs(max_move-min_move)
  n1_long=ceiling(range_move)
  !  write(0,*) 'n1_long',n1_long
  ! allocate(mm_interp(n1_long))

  if (flatten) then  ! WRIT OUT OUTPUT DIMENSIONS
     allocate(data_out(n1_long,n2),mm_interp(n1_long),data_panel(n1,n2))!,outwt(n1_long,n2,n3))
     call to_history ("n1",   n1_long)
     call to_history ("d1",d1/subsam) 
     call to_history ("o1",o1+min_shift*d1/subsam)
  else
     allocate(data_out(n1_aux,n2))!,outwt(n1,n2,n3))
     call to_history ("n1",   n1_aux)
     call to_history ("d1",d1*subsam) 
     call to_history ("o1",o1_aux)

  end if
  data_out=0.
  !outwt=0.

  ! write(0,*) 'min_move',min_move
  ! write(0,*) 'max_move',max_move
  ! write(0,*) 'range_move',range_move
!!$  write(0,*) 'size of data_out',size(data_out(1:,1,1)),size(data_out(1,1:,1)),size(data_out(1,1,1:))

  ! GOTO THE BIGINING OF INPUT TIME-SHIFT VOLUME
  call sseek("aux",0,0)
  !write(0,*) 'about to start second loop'
  loop_n3: do i3=1,n3
     call sreed("aux", time_shift_panel,4*n1_aux*n2)
     call sreed("in", data_panel,4*n1*n2)
     write(0,*) 'grabbed panel',i3,'of',n3
     data_out=0.
     mm_min=0.
     mm_max=0.
     do i2=1,n2
        counter=0

        if  (flatten) then

           do i1=1,n1_aux
!!!! store the shifts
              shift_var=((i1+1)-(time_shift_panel(i1,i2)-ref_trace(i1)))
              shifted_outputs(1,i1)=shift_var              ! store the shifts
              shifted_outputs(2,i1)=data_panel(i1,i2)  ! store the input data value
           end do

!!!! sort the shifts
           call quick_sort(shifted_outputs,1,2,n1_aux)  !sort by shift


!!! interpolate
           mm_min=ceiling(shifted_outputs(1,1)) 
           mm_max=floor(shifted_outputs(1,n1_aux))  ! or n1
           !                  write(0,*) 'mm_max',mm_max,'mm_min',mm_min,'min_shift',min_shift
           mm_sz=mm_max-mm_min+1 
           mm_interp=0.
           coord=>shifted_outputs(1,1:)   ! point the coord pointer at the sorted shifts
           !   write(0,*) 'size of coord',size(coord)
           call lint1_jesse_init(coord)
           !          write(0,*) 'before interp'
           stat1=lint1_jesse_lop(.true.,.true.,mm_interp(mm_min-min_shift:mm_max-min_shift) ,shifted_outputs(2,1:))
           data_out(mm_min-min_shift:mm_max-min_shift,i2)=mm_interp(mm_min-min_shift:mm_max-min_shift)

           mm_interp=0.


        else

!!$           !!just use nearest neightbor to unflatten
!!$           do i1=1,n1_aux
!!$              shift_var=((time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))*subsam
!!$              data_out(i1,i2,i3)=data_in(i1*subsam-int(shift_var)-min_shift,i2,i3) !
!!$
!!$           end do
!!$           shift_var=((time_cube(n1_aux,i2,i3)-time_cube(n1_aux,ref_2,ref_3)))*subsam
!!$           data_out(n1_aux,i2,i3)=data_in(n1_aux*subsam-ceiling(shift_var)-min_shift,i2,i3)
!!$           shift_var=((time_cube(1,i2,i3)-time_cube(1,ref_2,ref_3)))*subsam
!!$           data_out(1,i2,i3)=data_in(1*subsam-floor(shift_var)-min_shift,i2,i3)

        end if

     end do
     call sep_write (data_out)
  end do loop_n3

  ! write(0,*) 'after loops'
  call sep_close()
  call exit (0)





  deallocate(data_out)
!!$  call sep_close()
!!$  call exit (0)
end program Flatten_big














