program Flatten_inverse !
  !  unflatted a cube with a time shift cube
  !
  use sep
  use lint1
  use solver_smp_mod
  use solver_reg_mod
  use igrad1
  use cgstep_mod

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,knownvec1,knownvec2,data_out_index, shift_floor, shift_ceil, useinwt,ref_2,ref_3,flatten
  integer, dimension(:,:,:), allocatable    :: knownvec
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt
  real, save, pointer, dimension(:)         ::lint_in, lint_out
  real                                      ::shift,iprl, diffrl,shift_diff,upwt,dwnwt
  real,dimension(:)         ::mm_interp
  real, save, dimension(:),pointer                        ::coord
  real                                      ::shift_var
  real,   dimension(:), target    :: shifted_outputs

  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0);
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  call from_param("flatten",flatten,1);

  write(0,*) n1,n2,n3



  allocate (data_in (n1,n2,n3),time_cube(n1,n2,n3),data_out(n1,n2,n3),knownvec(n1,n2,n3),outwt(n1,n2,n3),inwt(n1,n2,n3))  
  allocate (shifted_outputs(n1))  !,inwt(n1,n2,n3)                             ! read data
  ! ; data = data / maxval (cabs (data)) ! normalize



  if (useinwt==0.) then
     inwt=1.
  else 
     call sreed("inwt", inwt,4*n1*n2*n3)
     write(0,*) 'min of outwt', minval(outwt),maxval(outwt), sum(outwt)/size(outwt)
  endif



  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2*n3)
  call sreed("aux", time_cube,4*n1*n2*n3)
  outwt=1.  !inwt
  data_in=data_in*inwt

  data_out=0.
  write(0,*) 'n1/n2/n3',n1,n2,n3
  write(0,*) 'max ref',maxval(time_cube(1:,ref_2,ref_3)),minval(time_cube(1:,ref_2,ref_3))

  do i3=1,n3
     do i2=1,n2

        shifted_outputs=0.
        if  (flatten) then ! IF FLATTEN

           do i1=1,n1
              shift_var=(i1-(time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))
              if (shift_var>=1.and.shift_var<=n1)then
                 shifted_outputs(i1)=shift_var              ! store the shifts
              end if
           end do

           coord=>shifted_outputs   ! point the coord pointer at the sorted shifts

           call lint1_init(0.,1.,coord)
!           call solver_smp(data_out(1:,i2,i3),data_in(1:,i2,i3),lint1_lop,cgstep,n1,verb=.false.)

   call solver_reg(data_out(1:,i2,i3),data_in(1:,i2,i3),lint1_lop,igrad1_lop,cgstep,n1,n1,1.,verb=.false.)
           call cgstep_close()
if ((i2+(i3-1)*n2)/10.-floor((i2+(i3-1)*n2)/10.)<.00001) then
           write(0,*) 'finished trace',i2+(i3-1)*n2,'of',n2*n3
end if
        else  ! IF UNFLATTEN


        end if
     end do
  end do


  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  !call to_history("d1",1)
  call sep_write (data_out) 

  outwt=outwt*inwt

  call to_history("n1",n1,"outwt"); call to_history("n2",n2,"outwt")
  call to_history("n3",n2,"outwt")
  call to_history("d1",1.0,"outwt"); call to_history("d2",1.0,"outwt")
  call to_history("d3",1.0,"outwt")
  call to_history("o1",0.,"outwt"); call to_history("o2",0.,"outwt")
  call to_history("o3",0.,"outwt")
  call to_history("esize",4,"outwt")
  call sep_write(outwt,"outwt")	





  deallocate (data_out)
  call sep_close()
  call exit (0)
end program Flatten_inverse














