program Precon
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use dipinteg_3D
  use dipinteg_precond
  use igrad3_period 
  use change_jl
  use fault_weight
  use igrad2
  use chain_mod
  use prec_oper
  use jesse_solver

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,k,k_max
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,stat1,stat2
  real                                       :: q,eps_t,eps_h,pi_var,beta,alpha
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:),   allocatable    ::ztrans
  real,    dimension (:),     allocatable    :: cos_wt
  real,    dimension(:),pointer              ::rt,hh,Fop,ww,tmp1,tmp2,rt_adj
  real,    dimension (:,:),   allocatable  ::hh_2D,tau,r,z,p
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,outwt
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3d
 real,    dimension  (2)   :: dot1,dot2
  call sep_init ()
  call from_history (n1,n2,n3, esize = 8)
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("mirror",mirror,1)
  call from_param("bounds",bounds,1)
  call from_param("slice",slice,0)




  allocate(data_in(n1,n2,1),px(n1,n2,1),py(n1,n2,1))






  ! CREATE PI VARIABLE
  pi_var=dacos(-1)





  allocate(hh(n1*n2))
  allocate(hh_2D(n1,n2))

  allocate(px_mirr(1,n1*2,n2*2))
  allocate(py_mirr(1,n1*2,n2*2))

  allocate( ztrans(2*n1,2*n2))
  allocate(outwt(n1,n2,n3),ww((n1)*(n2)*(n3)*2))
  call z_trans(2*n1,2*n2,ztrans)
  call sreed("wt", outwt,4*n1*n2*n3)
  ww=0.
  ww(1:(n1)*(n2)*(n3))=reshape(outwt,(/(n1)*(n2)*(n3)/))
  ww((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2)=reshape(outwt,(/(n1)*(n2)*(n3)/))
  ! deallocate(ww_3D)

  !do it=1,n3

  allocate( rt( n1*n2*2))

  call sep_read (data_in)

  ! BREAK INPUT CUBE INTO X DIP DIRECTION AND Y DIP DIRECTIONS
  px=real(data_in)  ! x direction dip

  py=aimag(data_in)  ! y direction dip
  !write(0,*) maxval(px),minval(px),sum(px)/size(px)
  rt=0.
  hh=0.


  rt(1:n1*n2)=reshape(px,(/size(px)/))
  rt(n1*n2+1:2*n1*n2)=reshape(py,(/size(py)/))
  call fault_w_init(ww)
  call igrad2_init(n1,n2)
  k_max=30
  allocate(tau(n1*n2,k_max),r(n1*n2,k_max),z(n1*n2,k_max),p(n1*n2,k_max))
  allocate(Fop(n1*n2),tmp2(n1*n2*2),tmp1(n1*n2*2))
  z=0.

  k=1 
  tau=0. 



  allocate( rt_adj(n1*n2*n3))


  ! APPLY DIVERGENCE
  !   stat1=igrad3_period_eps_lop(.true.,.false.,rt_adj , rt) 
  stat1=igrad2_lop(.true.,.false.,rt_adj , rt) 
  r(:,1)=rt_adj
call prec_oper_init(n1,n2,ww)

  do

     if (k/=1) then
!!$        allocate( rt( n1*n2*2))
        rt_adj=r(:,k)
     end if

     call dipintegrate_precond (rt_adj,z(:,k),eps_t,eps_h,1,n1,n2,ztrans)   

     ! hh_2D=reshape(hh,(/n1,n2/))
     !   r(k)=rt
     k=k+1
     write(0,*) 'k',k
     if (k==2) then
        p(:,k)=z(:,k-1)
     else
        beta=sum(dprod(r(:,k-1),z(:,k-1)))/sum(dprod(r(:,k-2),z(:,k-2)))
write(0,*) 'beta',beta
        p(:,k)=z(:,k-1)+beta*p(:,k-1)
     end if

      !  call chain (fault_w_oper,igrad2_lop,.false.,.false.,p(:,k),Fop,tmp1)

!stat1=prec_oper_ex(.false.,.false.,p(:,k),tmp1)   



!call dot_test (prec_oper_ex,n1*n2,n1*n2*2,dot1,dot2)
  stat2 = igrad2_lop (.false., .false., p(:,k), tmp1)
     stat1 = fault_w_oper (.false., .false., tmp1, tmp2)
     stat2 = igrad2_lop (.true., .false., Fop, tmp2)

     alpha=sum(dprod(r(:,k-1),z(:,k-1)))/sum(dprod(p(:,k),Fop))
     tau(:,k)=tau(:,k-1)+alpha*p(:,k)
write(0,*) 'alpha',alpha
     r(:,k)=r(:,k-1)-alpha*Fop
write(0,*) 'residual',sum(r(:,k))
     if (k>=k_max.or.abs(sum(r(:,k)))<.08*abs(sum(r(:,1)))) exit

  end do




allocate(tau_3d(256,n1,n2))
do it=1, 256
   tau_3d(it,:,:)=reshape(tau(:,k),(/n1,n2/))
end do

  call sep_write (tau_3d) 


  call to_history ("n1",   256)
  call to_history ("n2",   n1)
  call to_history ("n3",   n2)    
  call to_history ("esize",4)
  call sep_close()
  call exit (0)






end program Precon











