program Precon_std_2D
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use dipinteg_3D
  use dipinteg_precond
  use igrad3_period 
  use change_jl
  use fault_weight_cheap
  use igrad2
  use igrad2_epst
  use chain_mod
  use prec_oper
  use cgstep_jesse_mod
  use polydiv
  use lapfac2
  use solver_prc_mod
  use solver_smp_jesse_3D_mod

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,k,k_max,niter
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,stat1,stat2 
  integer                                    ::method,na
  real                                       :: q,eps_t,eps_h,pi_var,beta,alpha,epsi
  double precision     :: alpha_new,beta_new
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:),   allocatable    ::ztrans
  real,    dimension (:),     allocatable    :: cos_wt
  real,    dimension(:),pointer              ::rt,hh,Fop,ww,ww1,ww_reg,tmp1,tmp2,rt_adj,tmp3,rt_wt
  real,    dimension (:,:),   allocatable  ::hh_2D,tau,r,z,p
  real,    dimension (:),   allocatable      ::s,BigR,BigS,g,BigG,init_m
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,outwt
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3d
  real,    dimension  (2)   :: dot1,dot2
  type(filter)      :: aa
  logical ::forget
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("mirror",mirror,1)
  call from_param("bounds",bounds,1)
  call from_param("slice",slice,0)

  call from_param("method",method,1)
  call from_param("niter",niter,10)

  allocate(px(n1,n2,n3))
  write(0,*) '1'

  ! CREATE PI VARIABLE
  pi_var=dacos(-1)




  !  allocate( ztrans3d(n1,2*n2,2*n3))
  allocate(ww(n1*n2*n3*2),ww1(n1*n2*n3),ww_reg(n1*n2*n3))
  ! call z_trans(2*n1,2*n2,ztrans)
  call sreed("wt", ww1,4*n1*n2*n3)
  write(0,*) '2' 
  call sreed("wt_reg", ww_reg,4*n1*n2*n3)
  write(0,*) '3'
  ww=0.
  ww(1:(n1)*(n2)*(n3))=ww_reg
  ww((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2)=ww1

  allocate( rt( n1*n2*n3*2))
  write(0,*) '2'
  call sep_read (px)

  ! BREAK INPUT CUBE INTO X DIP DIRECTION AND Y DIP DIRECTIONS
!!$  px=real(data_in)  ! x direction dip
!!$
!!$  py=aimag(data_in)  ! y direction dip
!!$  deallocate(data_in) 

  !write(0,*) maxval(px),minval(px),sum(px)/size(px)
  rt=0.
  rt(n1*n2*n3+1:n1*n2*n3*2)=reshape(px,(/size(px)/))
  ! rt(n1*n2*n3*2+1:3*n1*n2*n3)=reshape(py,(/size(py)/))


  deallocate(px)
  call fault_w_init(ww)
  !  call igrad2_init(n1,n2)
  write(0,*) 'n1,n2,n3',n1,n2,n3
  !  call igrad3_epst_init(n1,n2,n3,eps_t)
  call igrad2_epst_init(n1,n2,eps_t)
  !  call dot_test (igrad3_epst_lop,n1*n2*n3,n1*n2*n3*3,dot1,dot2)

  write(0,*) 'initiallized igrad3_epst'
  !method=1

  k=1
  na=10
  epsi=.1
  !  eps_t=0.
  !   aa = lapfac2(epsi,n1,na) ! REMOVED
  write(0,*) 'about to factor laplacian' 
  ! aa = lapfac3d(epsi,n1,n2,na,eps_t) ! REMOVED
  aa = lapfac2d(epsi,n1,na,eps_t) 
  write(0,*) 'factored laplacian' 
  call polydiv_init(n1*n2*n3,aa) ! REMOVED
 call dot_test (igrad2_epst_lop,n1*n2,n1*n2*2,dot1,dot2)
  allocate(tau(n1*n2*n3,k))
  write(0,*) 'beginning solver'
  call solver_prc(tau(:,k), rt,igrad2_epst_lop,polydiv_lop,cgstep,n1*n2*n3,niter,0.,Wop=fault_w_oper,verb=.true.)
  ! call solver_smp(tau(:,k), rt,igrad2_epst_lop,cgstep,niter,Wop=fault_w_oper,verb=.true.)

  call cgstep_close ()
  write(0,*) 'passed solver'

  call sep_write (tau(:,k)) 


  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)
  call sep_close()
  call exit (0)






end program Precon_std_2D











