program Unflatten_w_cube_slices  !
  !  unflatted a cube with a time slice
  !
  use sep
  use lint1

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,knownvec1,knownvec2,data_out_index,subsam, shift_floor, shift_ceil
  integer, dimension(:,:,:), allocatable    :: knownvec
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube
  real, save, pointer, dimension(:)         ::lint_in, lint_out
  real, save, pointer                        ::coord
  real                                      ::shift,iprl, diffrl,shift_diff,upwt,dwnwt
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call to_history ("esize",4)
  write(0,*) n1,n2,n3

  subsam=1
  allocate (data_in (n1,n2,n3),time_cube(n1,n2,n3),data_out(n1*subsam,n2,n3),knownvec(n1,n2,n3))                                   ! read data
  ! ; data = data / maxval (cabs (data)) ! normalize

  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2*n3)
  call sreed("aux", time_cube,4*n1*n2*n3)

  write(0,*) 'min/max/(time_slc)',minval(time_cube),maxval(time_cube)
  !data_in=0.
  !data_in(100,:,:)=1.

  data_out=0.
  write(0,*) 'n1/n2/n3',n1,n2,n3
!data_out(1,:,:)=data_in(1,:,:)
  do i3=1,n3
     do i2=1,n2
        do i1=1,n1
           !         write(0,*) time_slc(i2,i3)

           data_out_index=(i1)*subsam -1*(subsam-1)
          
!           shift= nint(subsam*(time_cube(i1,i2,i3)-i1+n1/2))  
           shift=subsam*(time_cube(i1,i2,i3)) !  -5.4
           shift_floor=floor(shift)  ! -6
           shift_ceil=shift_floor+1 ! -5
           shift_diff=shift-shift_floor !  -5.4 - - 6 =.4
!write(0,*) shift, shift_floor, shift_ceil, shift_diff
           upwt = shift_diff  !   .4 
           dwnwt= 1-shift_diff !   .6
!upwt=1.
!dwnwt=0.


           !          shift= nint(subsam*(time_cube(i1,i2,i3)-i1*subsam+n1/2))  

           !write(0,*) shift
           !shift=0
           !      write(0,*) nint(time_cube(i1,i2,i3))
           if (data_out_index-shift_floor>n1*subsam-(subsam-1).OR.data_out_index-shift_ceil<1) then
 !             data_out(data_out_index,i2,i3)=0.
           else
              !     data_out(i1,i2,i3)=data_in((shift+i1),i2,i3)
     !         knownvec(i1,i2,i3)=data_out_index-shift
     !         data_out(nint(knownvec(i1,i2,i3)),i2,i3)=data_in(i1,i2,i3)

              knownvec(i1,i2,i3)=data_out_index-shift_floor
!write(0,*) data_out_index-shift_floor, data_out_index-shift_ceil, i1
              data_out( data_out_index-shift_floor  ,i2,i3)=data_out( data_out_index-shift_floor  ,i2,i3)+ dwnwt *data_in(i1,i2,i3)
              data_out( data_out_index-shift_ceil   ,i2,i3)=data_out( data_out_index-shift_ceil   ,i2,i3)+ upwt*data_in(i1,i2,i3)

           end if
        end do
     end do
  end do

  write(0,*) knownvec(10:30,6,6)
  !! linear interpolation
  do i3=1,n3
     do i2=1,n2
        do i1=1,n1-1
           knownvec1=knownvec(i1,i2,i3)
           knownvec2=knownvec(i1+1,i2,i3)

           diff=knownvec2-knownvec1
           !           write(0,*) 'diff',diff
           if (diff >=3) then
!write(0,*) knownvec1,knownvec2
              do ip=1,diff-2
                 iprl=ip
                 diffrl=diff-1.
                 !                 write(0,*) 'data_out',data_out(knownvec1,i2,i3),data_out(knownvec2,i2,i3),ip, (1-iprl/diffrl),(ip/diff),diffrl,iprl
!write(0,*) data_out(knownvec1-1,i2,i3)
 !               data_out(knownvec1+ip+1,i2,i3)=data_out(knownvec1+1,i2,i3)*(1.-iprl/diffrl) + data_out(knownvec2,i2,i3)*(iprl/diffrl)
 
  data_out(knownvec1+ip,i2,i3)=data_out(knownvec1,i2,i3)*(1.-iprl/diffrl) + data_out(knownvec2-1,i2,i3)*(iprl/diffrl)
                !             data_out(knownvec1,i2,i3)=100.
                 !                write(0,*) data_out( knownvec1+ip ,i2,i3) 
!write(0,*) knownvec1, knownvec2,knownvec1+ip+1,(1.-iprl/diffrl) 
              end do
           end if
        end do
     end do
  end do

  call to_history ("n1",   n1*subsam)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history("d1",1./subsam)
  call sep_write (data_out) 

  deallocate (data_out)
  call sep_close()
  call exit (0)
end program Unflatten_w_cube_slices














