program comp_test !
  !  unflatted a cube with a time shift cube
  !
  use sep
  use lint1
  use lint1_jesse
  use sorting_mod

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,it,data_out_index,subsam, shift_floor, shift_ceil, useinwt,n1_long,min_shift,counter,max_shift
  integer ::mm_min, mm_max, mm_sz,n1_aux,n1_out,ref_2,ref_3
  integer :: is_allocate
  real :: d1,d2,d3,o1,o2,o3,o1_aux
  real,   dimension(:,:), target    :: shifted_outputs
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt
  real, save, pointer, dimension(:)         ::lint_in, lint_out,shift_vec,shifted_test
  real,dimension(:)         ::mm_interp
  real, save, dimension(:),pointer                        ::coord
  real                                      ::shift_var,iprl, diffrl,shift_diff,upwt,dwnwt,max_move,min_move,range_move
  logical :: flatten
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call from_aux("aux",n1_aux)  
  call from_aux("aux","o1",o1_aux)  
  !write(0,*) 'n1_aux',n1_aux
  !write(0,*) 'o1_aux',o1_aux
  !stop
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0)
  call from_param("subsample",subsam,1)
  call from_param("flatten",flatten,.true.)
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  write(0,*) 'ref_2/ref_3 coordinates of reference trace',ref_2,ref_3

  call from_history ("d1",d1,1.) ; call from_history ("o1",o1,0.)
  call from_history ("d2",d2,1.) ; call from_history ("o2",o2,0.)
  call from_history ("d3",d3,1.) ; call from_history ("o3",o3,0.)






  allocate (data_in (n1,n2,n3),time_cube(n1_aux,n2,n3),shift_vec(n1_aux*n2*n3),shifted_outputs(2,n1_aux))  !,inwt(n1,n2,n3)                                ! read data
  ! ; data = data / maxval (cabs (data)) ! normalize
  inwt=0.
  if (useinwt==0.) then
     inwt=1.
  else 
     call sreed("inwt", inwt,4*n1*n2*n3)

  endif



  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2*n3)
  call sreed("aux", time_cube,4*n1_aux*n2*n3)

  write(0,*) 'min/max/(time_slc)',minval(time_cube),maxval(time_cube)
  !data_in=0.
  !data_in(100,:,:)=1.
  !time_cube=0.

  write(0,*) 'n1/n2/n3',n1,n2,n3
  !data_out(1,:,:)=data_in(1,:,:)

  !compute range in order to preserve data
  it=0  
  do i3=1,n3
     do i2=1,n2
        do i1=1,n1_aux      
           it=it+1
           ! COMPUTE SHIFT IN ABSOLUTE SAMPLE VALUES
           shift_vec(it)=(i1-(time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3))) !  -5.4
           !              write(0,*) 'shift_vec',shift_vec(it) 
           !       end if
        end do
     end do
  end do
  max_move=maxval(shift_vec(1:it))
  min_move=minval(shift_vec(1:it))
  min_shift=nint(min_move) !min_shift=floor(min_move)
  max_shift=nint(max_move)  !ceiling(max_move)
  range_move=abs(max_shift-min_move)+1
  n1_long=ceiling(range_move)
  write(0,*) 'max_move',max_move,'min_move',min_move,'max_shift',max_shift,'min_shift',min_shift,'range_move',range_move,n1_long
  write(0,*) 'n1_long',n1_long,'n1_aux',n1_aux
  allocate(mm_interp(n1_long))

  if (flatten) then
     allocate(data_out(n1_long,n2,n3),outwt(n1_long,n2,n3))
     call to_history ("n1",   n1_long)
     call to_history ("d1",d1) 
     call to_history ("n1",   n1_long,"outwt")
     call to_history ("d1",d1,"outwt") 
     call to_history ("o1",o1+(min_shift-1)*d1)


     call to_history ("n1",   n1_long)
     call to_history ("d1",d1) 

  else
     allocate(data_out(n1_aux,n2,n3),outwt(n1,n2,n3))
     call to_history ("n1",   n1_aux)
     call to_history ("d1",d1*subsam) 
     call to_history ("o1",o1_aux)

  end if
  data_out=0.
  outwt=0.

  write(0,*) 'min_move',min_move
  write(0,*) 'max_move',max_move
  write(0,*) 'range_move',range_move
  write(0,*) 'size of data_out',size(data_out(1:,1,1)),size(data_out(1,1:,1)),size(data_out(1,1,1:))



  do i3=1,n3
     do i2=1,n2
        counter=0

        if  (flatten) then
           ! LOOP OVER EACH VALUE IN TAU VOLUME
           do i1=1,n1_aux
              ! COMPUTE SHIFT IN ABSOLUTE SAMPLE VALUES, THIS WILL TELL US WHERE TO PUT EACH SAMPLE
              shift_var=(i1-(time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))

              ! PUT SHIFT VALUE IN ARRAY
              shifted_outputs(1,i1)=shift_var              ! store the shifts
              ! PUT THE ASSOCATED DATA VALUE IN ARRAY
              shifted_outputs(2,i1)=data_in(i1,i2,i3)  ! store the input data value

           end do

           ! SORT THE ARRAY BY SHIFT VALUE
           call quick_sort(shifted_outputs,1,2,n1_aux)  !sort by shift


           ! DETERMINE MIN AND MAX SHIFT BY ROUNDING UP THE MIN SHIFT AND ROUNDING DOWN THE MAX SHIFT
           mm_min=ceiling(shifted_outputs(1,1)) 
           mm_max=floor(shifted_outputs(1,n1_aux))  ! or n1

           mm_sz=mm_max-mm_min+1 

           mm_interp=0.
           coord=>shifted_outputs(1,1:)   ! point the coord pointer at the sorted shifts

           call lint1_jesse_init(coord)

           stat1=lint1_jesse_lop(.true.,.true.,mm_interp(mm_min:mm_max) ,shifted_outputs(2,1:))

           data_out(mm_min:mm_max,i2,i3)=mm_interp(mm_min:mm_max)
           mm_interp=0.

        else
           ! GRABBING SAMPLES TO UNFLATTEN
           do i1=1,n1_aux
              shift_var=i1-((time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))
              data_out(i1,i2,i3)=data_in(i1-int(shift_var)-min_shift,i2,i3) !
           end do
           shift_var=((time_cube(n1_aux,i2,i3)-time_cube(n1_aux,ref_2,ref_3)))
           data_out(n1_aux,i2,i3)=data_in(n1_aux-ceiling(shift_var)-min_shift,i2,i3)
           shift_var=((time_cube(1,i2,i3)-time_cube(1,ref_2,ref_3)))
           data_out(1,i2,i3)=data_in(1-floor(shift_var)-min_shift,i2,i3)

        end if
     end do
  end do

  write(0,*) 'after loops'



  write(0,*) 'center trace:n1,n2', int(n2/2),int(n3/2)
  write(0,*) 'min_shift',min_shift
  write(0,*) 'o1',o1,'d1',d1
  !  call to_history ("n1",   n1_long)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  ! call to_history ("o1",o1+min_shift*d1/subsam)
  call to_history ("o2",o2)
  call to_history ("o3",o3)
  !   call to_history ("d1",d1/subsam)  
  call to_history ("d2",d2)
  call to_history ("d3",d3) 

  !call to_history("d1",1)
  call sep_write (data_out)

  !outwt=outwt*inwt

  !call to_history("n1",n1_long,"outwt"); 
  call to_history("n2",n2,"outwt")
  call to_history("n3",n3,"outwt")
  ! call to_history("d1",d1,"outwt"); 
  call to_history("d2",d2,"outwt")
  call to_history("d3",d3,"outwt")
  call to_history("o1",o1+min_shift*d1/subsam,"outwt"); call to_history("o2",o2,"outwt")
  call to_history("o3",o3,"outwt")
  call to_history("esize",4,"outwt")
  call sep_write(outwt,"outwt")	

  call to_history("n1",n1,"indat"); call to_history("n2",n2,"indat")
  call to_history("n3",n3,"indat")
  call to_history("d1",d1,"indat"); call to_history("d2",d2,"indat")
  call to_history("d3",d3,"indat")
  call to_history("o1",o1,"indat"); call to_history("o2",02,"indat")
  call to_history("o3",o3,"indat")
  call to_history("esize",4,"indat")
  call sep_write(data_in,"indat")	


  call to_history("n1",n1,"time_cube"); call to_history("n2",n2,"time_cube")
  call to_history("n3",n3,"time_cube")
  call to_history("d1",d1,"time_cube"); call to_history("d2",d2,"time_cube")
  call to_history("d3",d3,"time_cube")
  call to_history("o1",o1,"time_cube"); call to_history("o2",o2,"time_cube")
  call to_history("o3",o3,"time_cube")
  call to_history("esize",4,"time_cube")
  call sep_write(time_cube,"time_cube")	


  deallocate(data_out)
  call sep_close()
  call exit (0)
end program comp_test














