module dipinteg_3D  
  use cgstep_mod
  use sep
 use igrad3_period_eps
  use igrad2
use igrad2_3d
  use solver_smp_mod
  use fft_data_mod
  use change_jl
  use dottest
  use flat_mod

implicit none
  contains
    subroutine dipintegrate_3D( rt,hh,eps_t,eps_h,n1,n2,n3)
      integer		       :: n1,n2,n3,stat1,div,mirror_len
      integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

      complex		       :: Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
      complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
      complex                  :: kern7
      real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
      real                     ::eps_t,eps_h
      real,allocatable                     :: py(:,:,:),pz(:,:,:),cos_wt(:),px(:,:,:)
      double precision         :: pi_var
      real, allocatable        :: rt_adj(:),FrequRangeX(:), FrequRangeY(:)
      real, pointer            :: rt(:)
      real, allocatable        :: FrequRangeZ(:)
      real, allocatable        :: Outphase(:,:,:), rt_adj_3D(:,:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
      real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
      complex, allocatable     :: OutY(:,:,:),rt_adj_cmp3D(:,:,:),zz(:,:,:)
      real,    dimension  (2)   :: dot1,dot2

      type(fft_type)           :: fft_3d_id

      ! GET DIMENSIONS
!!$      n1 = size( pz, 1) 
!!$      n2 = size( pz, 2)
!!$      n3 = size( pz, 3)

      ! CREATE PI VARIABLE
      pi_var=acos(-1.)

      ! ALLOCATE 
      write(0,*) 'allocating rts'
      !    write(0,*) 'n1/n2/n3',n1,n2,n3

      ! allocate( rt( n1*n2*n3*3))
      !   call igrad3_period_eps_init(10,10,1,1.,1.)
      !   call dot_test (igrad3_period_eps_lop,100,200,dot1,dot2)
      !     write(0,*) 'allocated rts'
      ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
      call igrad3_period_eps_init(n1,n2,n3,eps_t,eps_h)
call igrad2_3d_init(n1,n2,n3,eps_h)
!!$      call igrad2_init(n2,n3)

      ! call dot_test (igrad3_period_eps_lop,100,200,dot1,dot2)

      !      write(0,*) 'max/min pz',maxval(pz),minval(pz),sum(pz)
!!$      write(0,*) 'max/min px',maxval(px),minval(px),sum(px)
!!$      write(0,*) 'max/min py',maxval(py),minval(py),sum(py)
      ! RESHAPE TO 1D
      !rt(1:n1*n2*n3)		        =reshape(pz,(/size(pz)/))  
      !rt(n1*n2*n3+1:2*n1*n2*n3)	        =reshape(px,(/size(px)/))
      !rt(2*n1*n2*n3+1:3*n1*n2*n3)	=reshape(py,(/size(py)/))
      !   deallocate(pz,px,py)
      allocate( rt_adj(n1*n2*n3))

      write(0,*) 'applying divergence',n1,n2,n3
      ! APPLY DIVERGENCE
       !  stat1=igrad3_period_eps_lop(.true.,.false.,rt_adj , rt) 
    stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 
!!$      stat1=igrad2_lop(.true.,.false.,rt_adj , rt) 




      ! RESHAPE TO 3D
      deallocate(rt)
      allocate ( rt_adj_3D(n1,n2,n3) )

      rt_adj_3D=reshape(rt_adj,(/n1,n2,n3/))
      deallocate(rt_adj)


!!$
!!$      call to_history ("n1",   n1,"div")
!!$      call to_history ("n2",   n2,"div")
!!$      call to_history ("n3",   n3,"div")    
!!$      call to_history ("esize",4,"div")
!!$      call sep_write (rt_adj_3D,"div")


      ! TAPER DIVERGENCE
      div=2
      if (div==1) then
         n2=n2-1
         n3=n3-1
         taper_len=10 !n2/5
         allocate(cos_wt(taper_len))
         do ir=0,taper_len-1
            cos_wt(ir+1)=dcos((pi_var/2)*(real(ir)/(taper_len-1)))
         end do
         allocate(rt_adj_tap(n1,n2+2*taper_len,n3+2*taper_len))
         rt_adj_tap=0.
         rt_adj_tap(1:n1,taper_len+1:taper_len+n2,taper_len+1:taper_len+n3)=rt_adj_3D(:,1:n2,1:n3)
         deallocate(rt_adj_3D)

!!$         do it=1,n1
!!$            do ix=1,n2+2*taper_len
!!$               do iy=1,n3+2*taper_len
!!$                  if (ix<=taper_len.and.iy<=taper_len) then ! if in region 1
!!$                     dist=(max(abs(ix-(taper_len+1)),abs(iy-(taper_len+1))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+1,taper_len+1)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>taper_len.and.iy<=taper_len.and.ix<=n2+taper_len) then ! if in region 2
!!$                     dist=abs(taper_len+1-iy)
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,ix,taper_len+1)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>n2+taper_len.and.iy<=taper_len) then ! if in region 3
!!$                     dist=(max(abs(ix-(n2+taper_len)),abs(iy-(taper_len+1))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,n2+taper_len,taper_len+1)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>n2+taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 4
!!$                     dist=abs(n2+taper_len-ix)
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+n2,iy)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>n2+taper_len.and.iy>n3+taper_len) then ! if in region 5
!!$                     dist=(max(abs(ix-(n2+taper_len)),abs(iy-(n3+taper_len))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+n2,taper_len+n3)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>taper_len.and.iy>n3+taper_len.and.ix<=n2+taper_len) then ! if in region 6
!!$                     dist=abs(n3+taper_len-iy)
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,ix,taper_len+n3)*cos_wt(dist)
!!$                  end if
!!$                  if (ix<=taper_len.and.iy>n3+taper_len) then ! if in region 7
!!$                     dist=(max(abs(ix-(taper_len+1)),abs(iy-(n3+taper_len))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+1,taper_len+n3)*cos_wt(dist)
!!$                  end if
!!$                  if (ix<=taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 8
!!$                     dist=abs(taper_len+1-ix)
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+1,iy)*cos_wt(dist)
!!$                  end if
!!$
!!$
!!$               end do
!!$            end do
!!$         end do

         do it=1,n1
            do ix=1,n2+2*taper_len
               do iy=1,n3+2*taper_len
!!$                  if (ix<=taper_len.and.iy<=taper_len) then ! if in region 1
!!$                     dist=(max(abs(ix-(taper_len+1)),abs(iy-(taper_len+1))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+1,taper_len+1)*cos_wt(dist)
!!$                  end if
                  if (ix>taper_len.and.iy<=taper_len.and.ix<=n2+taper_len) then ! if in region 2
                     dist=abs(taper_len+1-iy)
                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,ix,taper_len+1)*cos_wt(dist)
                  end if
!!$                  if (ix>n2+taper_len.and.iy<=taper_len) then ! if in region 3
!!$                     dist=(max(abs(ix-(n2+taper_len)),abs(iy-(taper_len+1))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,n2+taper_len,taper_len+1)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>n2+taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 4
!!$                     dist=abs(n2+taper_len-ix)
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+n2,iy)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>n2+taper_len.and.iy>n3+taper_len) then ! if in region 5
!!$                     dist=(max(abs(ix-(n2+taper_len)),abs(iy-(n3+taper_len))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+n2,taper_len+n3)*cos_wt(dist)
!!$                  end if
                  if (ix>taper_len.and.iy>n3+taper_len.and.ix<=n2+taper_len) then ! if in region 6
                     dist=abs(n3+taper_len-iy)
                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,ix,taper_len+n3)*cos_wt(dist)
                  end if
!!$                  if (ix<=taper_len.and.iy>n3+taper_len) then ! if in region 7
!!$                     dist=(max(abs(ix-(taper_len+1)),abs(iy-(n3+taper_len))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+1,taper_len+n3)*cos_wt(dist)
!!$                  end if
!!$                  if (ix<=taper_len.and.iy>taper_len.and.iy<=n3+taper_len) then ! if in region 8
!!$                     dist=abs(taper_len+1-ix)
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+1,iy)*cos_wt(dist)
!!$                  end if


               end do
            end do
         end do
         do it=1,n1
            do ix=1,n2+2*taper_len
               do iy=1,n3+2*taper_len
!!$                  if (ix<=taper_len.and.iy<=taper_len) then ! if in region 1
!!$                     dist=(max(abs(ix-(taper_len+1)),abs(iy-(taper_len+1))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+1,taper_len+1)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>taper_len.and.iy<=taper_len.and.ix<=n2+taper_len) then ! if in region 2
!!$                     dist=abs(taper_len+1-iy)
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,ix,taper_len+1)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>n2+taper_len.and.iy<=taper_len) then ! if in region 3
!!$                     dist=(max(abs(ix-(n2+taper_len)),abs(iy-(taper_len+1))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,n2+taper_len,taper_len+1)*cos_wt(dist)
!!$                  end if
                  if (ix>n2+taper_len) then ! if in region 4
                     dist=abs(n2+taper_len-ix)
                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+n2,iy)*cos_wt(dist)
                  end if
!!$                  if (ix>n2+taper_len.and.iy>n3+taper_len) then ! if in region 5
!!$                     dist=(max(abs(ix-(n2+taper_len)),abs(iy-(n3+taper_len))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+n2,taper_len+n3)*cos_wt(dist)
!!$                  end if
!!$                  if (ix>taper_len.and.iy>n3+taper_len.and.ix<=n2+taper_len) then ! if in region 6
!!$                     dist=abs(n3+taper_len-iy)
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,ix,taper_len+n3)*cos_wt(dist)
!!$                  end if
!!$                  if (ix<=taper_len.and.iy>n3+taper_len) then ! if in region 7
!!$                     dist=(max(abs(ix-(taper_len+1)),abs(iy-(n3+taper_len))))
!!$                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+1,taper_len+n3)*cos_wt(dist)
!!$                  end if
                  if (ix<=taper_len) then ! if in region 8
                     dist=abs(taper_len+1-ix)
                     rt_adj_tap(it,ix,iy)=rt_adj_tap(it,taper_len+1,iy)*cos_wt(dist)
                  end if


               end do
            end do
         end do












         ! REDEFINE n2 and n3
         n2=n2+2*taper_len
         n3=n3+2*taper_len
         allocate(rt_adj_3D(n1,n2,n3))
         rt_adj_3D=rt_adj_tap
         deallocate(rt_adj_tap)

         call to_history ("n1",   n2,"sub")
         call to_history ("n2",   n3,"sub")
         call to_history ("n3",   1,"sub")    
         call to_history ("esize",4,"sub")
         call sep_write (rt_adj_3D,"sub")

      else if (div==2) then ! mirror the divergence
         write(0,*) 'mirroring'
         !         allocate (diverg(n1,n2*2-2,n3*2-2))
         allocate (rt_adj_cmp3D(n1,n2*2,n3*2))
         rt_adj_cmp3D(1:n1,1:n2,1:n3)         = cmplx(rt_adj_3D(:,1:n2,1:n3),0.)
         rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
         rt_adj_cmp3D(1:n1,n2+1:n2*2,1:2*n3)= rt_adj_cmp3D(1:n1,n2:1:-1,1:2*n3);
         deallocate(rt_adj_3D)
         n2=2*n2
         n3=2*n3
         taper_len=0.
         write(0,*) 'done mirroring'
!!$         allocate( rt_adj_3D( n1,n2,n3))
!!$         rt_adj_3D=diverg
!!$         deallocate(diverg)


      else if (div==3) then ! shrink wrap mirror the divergence
         mirror_len=10
         allocate(subxy(n1,mirror_len,mirror_len),subx(n1,mirror_len,n3-1),suby(n1,n2-1,mirror_len))
         call anti_alias(rt_adj_3D(:,1:(n2-1),1:(n3-1)),subxy)
         call anti_alias(rt_adj_3D(:,1:(n2-1),1:(n3-1)),subx)
         call anti_alias(rt_adj_3D(:,1:(n2-1),1:(n3-1)),suby)

         allocate (diverg(n1,n2-1+mirror_len,n3-1+mirror_len))
         diverg(1:n1,1:n2-1,1:n3-1)       = rt_adj_3D(:,1:(n2-1),1:(n3-1))
         diverg(1:n1,1:n2-1,n3+1-1:n3-1+mirror_len)  = suby(1:n1,1:(n2-1),mirror_len:1:-1)
         diverg(1:n1,n2+1-1:n2-1+mirror_len,1:n3-1)  = subx(1:n1,mirror_len:1:-1,1:(n3-1))
         diverg(1:n1,n2+1-1:n2-1+mirror_len,n3+1-1:n3-1+mirror_len)=subxy(1:n1,mirror_len:1:-1,mirror_len:1:-1)
         deallocate(rt_adj_3D)
         n2=n2-1+mirror_len
         n3=n3-1+mirror_len
         allocate( rt_adj_3D( n1,n2,n3))
         rt_adj_3D=diverg
         deallocate(diverg)

         call to_history ("n1",   n2,"sub")
         call to_history ("n2",   n3,"sub")
         call to_history ("n3",   1,"sub")    
         call to_history ("esize",4,"sub")
         call sep_write (rt_adj_3D,"sub")




      else
         taper_len=0
      end if


!!$
!!$      call to_history ("n1",   n1,"div")
!!$      call to_history ("n2",   n2,"div")
!!$      call to_history ("n3",   n3,"div")    
!!$      call to_history ("esize",4,"div")
!!$      call sep_write (rt_adj_3D,"div")






!!$      call to_history ("n1",   n1,"div")
!!$      call to_history ("n2",   n2,"div")
!!$      call to_history ("n3",   n3,"div")    
!!$      call to_history ("esize",4,"div")
!!$      call sep_write (rt_adj_3D,"div")


!!$ call sep_init ()
!!$
!!$  call sep_write(rt,"rt") 
!!$call sep_close()

!!$      allocate(rt_adj_sub(n1,n2,n3/2))
!!$      call anti_alias(rt_adj_3D,rt_adj_sub)
!!$      call to_history ("n1",   n2,"sub")
!!$      call to_history ("n2",   n3/2,"sub")
!!$      call to_history ("n3",   1,"sub")    
!!$      call to_history ("esize",4,"sub")
!!$      call sep_write (rt_adj_sub,"sub")

!!$      ! ALLOCATE COMPLEX 3D
if (div==0) then
      allocate(rt_adj_cmp3D( n1,n2,n3))
      rt_adj_cmp3D=cmplx(rt_adj_3D,0.)
      deallocate(rt_adj_3D)
end if
      write(0,*) 'initializing FFTW'
      ! INITIALIZE FFTW
      fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
      write(0,*) 'after fft init',n1,n2,n3
      ! APPLY FFTW
      call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
      call clean_fft(fft_3d_id)
      write(0,*) 'after fft'

      delx=1.
      dely=1.
      delz=1.
      allocate(FrequRangeX(n1),FrequRangeY(n2), FrequRangeZ(n3),OutY(n1,n2,n3))
      OutY=0.
      !    write(0,*) 'n1/n2/n3',n1,n2,n3

      ! DEFINE FREQUENCY RANGES FOR EACH DIMENSION
      do i1=1,(n1/2+1)
         FrequRangeX(i1)=(1./n1)*(i1-1)
      end do
      do i1=n1/2+2,n1  
         FrequRangeX(i1)=-1*FrequRangeX(n1/2)+(1./n1)*(i1-n1/2-2)
      end do
      do i2=1,(n2/2+1)
         FrequRangeY(i2)=(1./n2)*(i2-1)
      end do
      do i2=n2/2+2,n2  
         FrequRangeY(i2)=-1*FrequRangeY(n2/2)+(1./n2)*(i2-n2/2-2)
      end do
      do i3=1,(n3/2+1)
         FrequRangeZ(i3)=(1./n3)*(i3-1)
      end do
      do i3=n3/2+2,n3  
         FrequRangeZ(i3)=-1*FrequRangeZ(n3/2)+(1./n3)*(i3-n3/2-2)
      end do


      ! COMPUTE Z TRANSFORM
      do i1=1, n1  
         do i2=1,n2  
            do i3=1,n3  
               kx=FrequRangeX(i1) 
               ky=FrequRangeY(i2) 
               kz=FrequRangeZ(i3) 
               kern1=cmplx(0.,-kx*delx*2.*pi_var)
               Ztrans1= -eps_t*exp(kern1) 
               kern2=cmplx(0., -ky*dely*2.*pi_var )
               Ztrans2= -exp(kern2) 
               kern3=cmplx(0., -kz*delz*2.*pi_var )
               Ztrans3= -eps_h*exp(kern3) 
               Ztrans4= 2.+2.*eps_t+2.*eps_h 
               kern5=cmplx(0.,kx*delx*2.*pi_var)
               Ztrans5= -eps_t*exp(kern5)
               kern6=cmplx(0.,ky*dely*2.*pi_var)
               Ztrans6= -exp(kern6)
               kern7=cmplx(0.,kz*delz*2.*pi_var)
               Ztrans7= -eps_h*exp(kern7)
               SumZtrans= Ztrans1 + Ztrans2 + Ztrans3 + Ztrans4 + Ztrans5 +Ztrans6&
               &+Ztrans7  
!write(0,*) 'ztran',SumZtrans
               if (SumZtrans/=0.) then
                  OutY(i1,i2,i3)  =rt_adj_cmp3D(i1,i2,i3)     /SumZtrans 

               end if
            end do
         end do
      end do
      deallocate(FrequRangeX,FrequRangeY,FrequRangeZ,rt_adj_cmp3D)

      write(0,*) 'about to do inverse FFTW'
      ! INVERSE FFTW
      fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
      call fft_3d_data(fft_3d_id,FFTW_BACKWARD,n1,n2,n3,OutY)
      call clean_fft(fft_3d_id)

      ! REDEFINE n2,n3 to pre-taper lengths
      if (div==1) then
         n2=n2-2*taper_len+1
         n3=n3-2*taper_len+1
      end if
      if (div==2) then
         n2=n2/2
         n3=n3/2
      end if
      if (div==3) then
         n2=n2+1-mirror_len
         n3=n3+1-mirror_len
      end if

      allocate(Outphase(n1,n2,n3))

      write(0,*) 'taper_len',taper_len

      Outphase=real(OutY(1:n1,taper_len+1:taper_len+n2,taper_len+1:taper_len+n3))
      ! n2=n2-2*taper_len
      ! n3=n3-2*taper_len

      deallocate(OutY)





      ! RESHAPE OUTPUT TO hh
      ! allocate(hh(n1*n2*n3))
      hh=reshape(Outphase,(/size(Outphase)/))
 
!!$      call to_history ("n1",   n1,"div")
!!$      call to_history ("n2",   n2,"div")
!!$      call to_history ("n3",   n3,"div")    
!!$      call to_history ("esize",4,"div")
!!$      call sep_write (hh,"div")

      deallocate(Outphase)
    end subroutine dipintegrate_3D
end module 
