module dipinteg_precond
  use cgstep_mod
  use sep
  use igrad3_period_eps
  use igrad2
  use solver_smp_mod
  use fft_data_mod
  use change_jl
  use dottest
  use flat_mod

  implicit none
contains
  subroutine dipintegrate_precond( rt_adj,hh,eps_t,eps_h,n1,n2,n3,ztrans)
    integer		       :: n1,n2,n3,stat1,div,mirror_len
    integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

    complex		       :: Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
    complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
    complex                  :: kern7
    real		       ::delx,dely,delz,kx,ky,kz,kernval1,eps_t,eps_h
    real,allocatable         ::  hh(:),py(:,:,:),pz(:,:,:),cos_wt(:),px(:,:,:)
    double precision         :: pi_var
    real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
    real, pointer            :: rt(:),rt_adj(:)
    real, allocatable        :: FrequRangeZ(:)
    real, allocatable        :: Outphase(:,:), rt_adj_3D(:,:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
    real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:),zz(:,:,:)
    complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
    complex                  :: ztrans(:,:)
    real,    dimension  (2)   :: dot1,dot2

    type(fft_type)           :: fft_2d_id



    ! CREATE PI VARIABLE
    pi_var=acos(-1.)


    ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
    !  call igrad3_period_eps_init(n1,n2,n3,eps_t,eps_h)
    !   call igrad2_init(n2,n3)
!!$
!!$    allocate( rt_adj(n1*n2*n3))
!!$
!!$
!!$    ! APPLY DIVERGENCE
!!$    !   stat1=igrad3_period_eps_lop(.true.,.false.,rt_adj , rt) 
!!$    stat1=igrad2_lop(.true.,.false.,rt_adj , rt) 

!!$    call to_history ("n1",   n2,"div")
!!$    call to_history ("n2",   n3,"div")
!!$    call to_history ("n3",   1,"div")    
!!$    call to_history ("esize",4,"div")
!!$    call sep_write (rt_adj,"div")



    ! RESHAPE TO 3D
    !   deallocate(rt)
    allocate ( rt_adj_3D(n1,n2,n3) )

    rt_adj_3D=reshape(rt_adj,(/n1,n2,n3/))

    ! deallocate(rt_adj)

    !  write(0,*) 'mirroring'
    !         allocate (diverg(n1,n2*2-2,n3*2-2))
!!$    allocate (rt_adj_cmp2D(n2*2-2,n3*2-2))
!!$    rt_adj_cmp2D(1:n2-1,1:n3-1)         = cmplx(rt_adj_3D(1,1:(n2-1),1:(n3-1)),0.)
!!$    rt_adj_cmp2D(1:n2-1,n3+1-1:2*n3-2)  = cmplx(rt_adj_3D(1,1:(n2-1),(n3-1):1:-1),0.)
!!$    rt_adj_cmp2D(n2+1-1:n2*2-2,1:2*n3-2)= rt_adj_cmp2D(n2-1:1:-1,1:2*n3-2);
!!$    deallocate(rt_adj_3D)
!!$    n2=2*n2-2
!!$    n3=2*n3-2

    allocate (rt_adj_cmp2D(n2*2,n3*2))
    rt_adj_cmp2D(1:n2,1:n3)         = cmplx(rt_adj_3D(1,1:(n2),1:(n3)),0.)
    rt_adj_cmp2D(1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1,1:(n2),(n3):1:-1),0.)
    rt_adj_cmp2D(n2+1:n2*2,1:2*n3)= rt_adj_cmp2D(n2:1:-1,1:2*n3);
    deallocate(rt_adj_3D)
    n2=2*n2
    n3=2*n3


    ! write(0,*) 'done mirroring'

    call to_history ("n1",   n2,"div2")
    call to_history ("n2",   n3,"div2")
    call to_history ("n3",   1,"div2")    
    call to_history ("esize",4,"div2")
    call sep_write (real(rt_adj_cmp2d),"div2")



    !  write(0,*) 'initializing FFTW'
    ! INITIALIZE FFTW
    fft_2d_id  =init_fft_2d (n2,n3)  
    !  write(0,*) 'after fft init',n1,n2,n3
    ! APPLY FFTW
    call fft_2d_data(fft_2d_id,FFTW_FORWARD,n2,n3,rt_adj_cmp2D)
    call clean_fft(fft_2d_id)

    allocate(OutY(n2,n3))
    OutY=0.

    where (ztrans/=0.) OutY=rt_adj_cmp2D/ztrans
    !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

    deallocate(rt_adj_cmp2D)
    !   write(0,*) 'about to do inverse FFTW'
    ! INVERSE FFTW
    fft_2d_id  =init_fft_2d (n2,n3)  
    call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n2,n3,OutY)
    call clean_fft(fft_2d_id)

!!$
!!$       n2=(n2+2)/2
!!$       n3=(n3+2)/2
    n2=(n2)/2
    n3=(n3)/2


    allocate(Outphase(n2,n3))

    !   write(0,*) 'taper_len',taper_len

    Outphase=real(OutY(1:n2,1:n3))
    ! n2=n2-2*taper_len
    ! n3=n3-2*taper_len

    deallocate(OutY)





    ! RESHAPE OUTPUT TO hh
    ! allocate(hh(n1*n2*n3))
    hh=reshape(Outphase,(/size(Outphase)/))

!!$      call to_history ("n1",   n1,"div")
!!$      call to_history ("n2",   n2,"div")
!!$      call to_history ("n3",   n3,"div")    
!!$      call to_history ("esize",4,"div")
!!$      call sep_write (hh,"div")

    deallocate(Outphase)
  end subroutine dipintegrate_precond

  subroutine z_trans( n2,n3,ztrans)
    integer		       :: n1,n2,n3,stat1,div,mirror_len
    integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

    complex		       :: Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
    complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
    complex                  :: kern7
    real                    ::eps_t,eps_h
    real		       :: delx,dely,delz,kx,ky,kz,kernval1
    real,allocatable              ::hh(:), py(:,:,:),pz(:,:,:),cos_wt(:),px(:,:,:)
    double precision         :: pi_var
    real, allocatable        :: rt_adj(:),FrequRangeX(:), FrequRangeY(:)
    real, pointer            :: rt(:)
    real, allocatable        :: FrequRangeZ(:)
    real, allocatable        :: Outphase(:,:,:), rt_adj_3D(:,:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
    real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
    complex, allocatable     :: zz(:,:,:),OutY(:,:,:),rt_adj_cmp3D(:,:,:),ztrans(:,:)
    real,    dimension  (2)   :: dot1,dot2

    type(fft_type)           :: fft_3d_id

    ! GET DIMENSIONS
!!$      n1 = size( pz, 1) 
!!$      n2 = size( pz, 2)
!!$      n3 = size( pz, 3)
    !write(0,*) 'making ztrans',n1,n2,n3
    ! CREATE PI VARIABLE
    pi_var=acos(-1.)

    n1=1
    eps_h=1.
    eps_t=1.

    delx=1.
    dely=1.
    delz=1.
    allocate(FrequRangeX(n1),FrequRangeY(n2), FrequRangeZ(n3))
    ! allocate(ztrans(n2,n3))

    !    write(0,*) 'n1/n2/n3',n1,n2,n3

    ! DEFINE FREQUENCY RANGES FOR EACH DIMENSION
    do i1=1,(n1/2+1)
       FrequRangeX(i1)=(1./n1)*(i1-1)
    end do
    do i1=n1/2+2,n1  
       FrequRangeX(i1)=-1*FrequRangeX(n1/2)+(1./n1)*(i1-n1/2-2)
    end do
    do i2=1,(n2/2+1)
       FrequRangeY(i2)=(1./n2)*(i2-1)
    end do
    do i2=n2/2+2,n2  
       FrequRangeY(i2)=-1*FrequRangeY(n2/2)+(1./n2)*(i2-n2/2-2)
    end do
    do i3=1,(n3/2+1)
       FrequRangeZ(i3)=(1./n3)*(i3-1)
    end do
    do i3=n3/2+2,n3  
       FrequRangeZ(i3)=-1*FrequRangeZ(n3/2)+(1./n3)*(i3-n3/2-2)
    end do


    ! COMPUTE Z TRANSFORM
    !  do i1=1, n1 
    i1=1 
    do i2=1,n2  
       do i3=1,n3  
          kx=FrequRangeX(i1) 
          ky=FrequRangeY(i2) 
          kz=FrequRangeZ(i3) 
          kern1=cmplx(0.,-kx*delx*2.*pi_var)
          Ztrans1= -eps_t*exp(kern1) 
          kern2=cmplx(0., -ky*dely*2.*pi_var )
          Ztrans2= -exp(kern2) 
          kern3=cmplx(0., -kz*delz*2.*pi_var )
          Ztrans3= -eps_h*exp(kern3) 
          Ztrans4= 2.+2.*eps_h 
          kern5=cmplx(0.,kx*delx*2.*pi_var)
          Ztrans5= -eps_t*exp(kern5)
          kern6=cmplx(0.,ky*dely*2.*pi_var)
          Ztrans6= -exp(kern6)
          kern7=cmplx(0.,kz*delz*2.*pi_var)
          Ztrans7= -eps_h*exp(kern7)
!!$             SumZtrans= Ztrans1 + Ztrans2 + Ztrans3 + Ztrans4 + Ztrans5 +Ztrans6&
!!$             &+Ztrans7 
          SumZtrans= Ztrans2 + Ztrans3 + Ztrans4  +Ztrans6 + Ztrans7 
          if (SumZtrans/=0.) then
             ! OutY(i1,i2,i3)  =rt_adj_cmp3D(i1,i2,i3)     /SumZtrans 
             ztrans(i2,i3)=SumZtrans
          else
             ztrans(i2,i3)=0.
          end if
       end do
    end do
    !  end do
    deallocate(FrequRangeX,FrequRangeY,FrequRangeZ)


  end subroutine z_trans

end module dipinteg_precond
