module dipinteg_precond_3D
  use cgstep_mod
  use sep
  use igrad3_period_eps
  use igrad3_epst
  use solver_smp_mod
  use fft_data_mod
  use change_jl
  use dottest
  use flat_mod

  implicit none
contains
  subroutine dipintegrate_precond_3D( rt,hh,eps_t,eps_h,n1,n2,n3,ztrans)
    integer		       :: n1,n2,n3,stat1,div,mirror_len
    integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

    complex		       :: zz(:,:,:),Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
    complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
    complex                  :: kern7
    real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1,px(:,:,:)
    real                     :: py(:,:,:),pz(:,:,:),eps_t,eps_h,cos_wt(:)
    double precision         :: pi_var
    real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
    real, pointer            :: rt(:),rt_adj(:)
    real, allocatable        :: FrequRangeZ(:)
    real, allocatable        :: Outphase(:,:,:), rt_adj_3D(:,:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
    real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
    complex, allocatable     :: OutY(:,:,:),rt_adj_cmp3D(:,:,:)
    complex                  :: ztrans(:,:,:)
    real,    dimension  (2)   :: dot1,dot2

    type(fft_type)           :: fft_3d_id



    ! CREATE PI VARIABLE
    pi_var=dacos(-1)


    ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
    !  call igrad3_period_eps_init(n1,n2,n3,eps_t,eps_h)
    call igrad3_epst_init(n1,n2,n3,eps_t)
!!$
    allocate( rt_adj(n1*n2*n3))


    ! APPLY DIVERGENCE
    !   stat1=igrad3_period_eps_lop(.true.,.false.,rt_adj , rt) 
    stat1=igrad3_epst_lop(.true.,.false.,rt_adj , rt) 

!!$    call to_history ("n1",   n2,"div")
!!$    call to_history ("n2",   n3,"div")
!!$    call to_history ("n3",   1,"div")    
!!$    call to_history ("esize",4,"div")
!!$    call sep_write (rt_adj,"div")



    ! RESHAPE TO 3D
    !   deallocate(rt)
    allocate ( rt_adj_3D(n1,n2,n3) )

    rt_adj_3D=reshape(rt_adj,(/n1,n2,n3/))

    deallocate(rt_adj)

    !  write(0,*) 'mirroring'
    !         allocate (diverg(n1,n2*2-2,n3*2-2))
!!$    allocate (rt_adj_cmp2D(n2*2-2,n3*2-2))
!!$    rt_adj_cmp2D(1:n2-1,1:n3-1)         = cmplx(rt_adj_3D(1,1:(n2-1),1:(n3-1)),0.)
!!$    rt_adj_cmp2D(1:n2-1,n3+1-1:2*n3-2)  = cmplx(rt_adj_3D(1,1:(n2-1),(n3-1):1:-1),0.)
!!$    rt_adj_cmp2D(n2+1-1:n2*2-2,1:2*n3-2)= rt_adj_cmp2D(n2-1:1:-1,1:2*n3-2);
!!$    deallocate(rt_adj_3D)
!!$    n2=2*n2-2
!!$    n3=2*n3-2

    allocate (rt_adj_cmp3D(n1,n2*2,n3*2))
    rt_adj_cmp3D(1:n1,1:n2,1:n3)         = cmplx(rt_adj_3D(1:n1,1:n2,1:n3),0.)
    rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
    rt_adj_cmp3D(1:n1,n2+1:n2*2,1:2*n3)= rt_adj_cmp3D(1:n1,n2:1:-1,1:2*n3);
    deallocate(rt_adj_3D)
    n2=2*n2
    n3=2*n3


    ! write(0,*) 'done mirroring'

!!$    call to_history ("n1",   n2,"div2")
!!$    call to_history ("n2",   n3,"div2")
!!$    call to_history ("n3",   1,"div2")    
!!$    call to_history ("esize",4,"div2")
!!$    call sep_write (real(rt_adj_cmp2d),"div2")



!!$    !  write(0,*) 'initializing FFTW'
!!$    ! INITIALIZE FFTW
!!$    fft_2d_id  =init_fft_2d (n2,n3)  
!!$    !  write(0,*) 'after fft init',n1,n2,n3
!!$    ! APPLY FFTW
!!$    call fft_2d_data(fft_2d_id,FFTW_FORWARD,n2,n3,rt_adj_cmp2D)
!!$    call clean_fft(fft_2d_id)

 !   write(0,*) 'initializing FFTW'
    ! INITIALIZE FFTW
    fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
  !  write(0,*) 'after fft init',n1,n2,n3
    ! APPLY FFTW
    call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
    call clean_fft(fft_3d_id)
   ! write(0,*) 'after fft'

    allocate(OutY(n1,n2,n3))
    OutY=0.

    where (ztrans/=0.) OutY=rt_adj_cmp3D/ztrans
    !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

    deallocate(rt_adj_cmp3D)
    !   write(0,*) 'about to do inverse FFTW'
!!$    ! INVERSE FFTW
!!$    fft_2d_id  =init_fft_2d (n2,n3)  
!!$    call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n2,n3,OutY)
!!$    call clean_fft(fft_2d_id)

    ! INVERSE FFTW
    fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
    call fft_3d_data(fft_3d_id,FFTW_BACKWARD,n1,n2,n3,OutY)
    call clean_fft(fft_3d_id)
!!$
!!$       n2=(n2+2)/2
!!$       n3=(n3+2)/2
    n2=(n2)/2
    n3=(n3)/2


    allocate(Outphase(n1,n2,n3))

    !   write(0,*) 'taper_len',taper_len

    Outphase=real(OutY(1:n1,1:n2,1:n3))
    ! n2=n2-2*taper_len
    ! n3=n3-2*taper_len

    deallocate(OutY)





    ! RESHAPE OUTPUT TO hh
    ! allocate(hh(n1*n2*n3))
    hh=reshape(Outphase,(/size(Outphase)/))

!!$      call to_history ("n1",   n1,"div")
!!$      call to_history ("n2",   n2,"div")
!!$      call to_history ("n3",   n3,"div")    
!!$      call to_history ("esize",4,"div")
!!$      call sep_write (hh,"div")

    deallocate(Outphase)
  end subroutine dipintegrate_precond_3D


end module dipinteg_precond_3D
