module lapfac3

  use wilson
  use helix

  implicit none

contains
  
  function lapfac3d( eps, n1, n2, na,eps_t) result (aa)

    type(filter)        :: aa, lap
    real,    intent(in) :: eps,eps_t
    integer, intent(in) :: n1, n2, na
    integer             :: i,j
    real                :: a0, lap0

    call allocatehelix(lap, 3)    ! laplacian filter
    lap0 = 4. +2.*eps_t + eps                ! zero lag coeff.
    lap%lag = (/ 1, n1, n1*n2 /)  ! lag(1)=1;lag(2)=n1;lag(3)=n1*n2
    lap%flt = -1                  
    lap%flt(1)=-1*eps_t

    call allocatehelix(aa, 3*na)
    aa%flt = 0.

    do i=1,na 
       aa%lag(i) = i
       aa%lag(na+i) = n1 + i - na
       aa%lag(2*na+i) = n1*n2 + i - na
    end do

    call wilson_init(10*n1*n2)
    write(0,*) 'about to apply wilson_factor'
    call wilson_factor(5, lap0, lap, a0, aa,verb=.true.)
    write(0,*) 'applied wilson_factor'
    call wilson_close()
    call deallocatehelix(lap)

  end function lapfac3d

end module lapfac3


