module prec_oper
  use igrad2
  use fault_weight
  use chain_mod
  integer,save			  	     :: n1_main,n2_main

contains
  subroutine prec_oper_init(n1_in,n2_in,ww) 
    integer			  	     :: n1_in,n2_in
    real,    dimension(:),pointer              ::ww
    write(0,*) 'prec_oper_INIT'
    n1_main=n1_in
    n2_main=n2_in
    call fault_w_init(ww)
    call igrad2_init(n1_in,n2_in)
  end subroutine prec_oper_init


  integer function prec_oper_ex( adj, add, model, data) 
    logical       :: adj, add
    real          :: data(:),model(:)
    real,    dimension(:),pointer              ::tmp1,tmp2
    integer                                    ::stat


    allocate(tmp1(n1_main*n2_main*2),tmp2(n1_main*n2_main*2))
  
  call chain (igrad2_adj_lop,fault_w_oper,igrad2_lop,adj,add,model,data,tmp1,tmp2)

    deallocate(tmp1)

  end function prec_oper_ex

  integer function igrad2_adj_lop( adj, add, model, data) 
    logical       :: adj, add
    integer       ::stat
    real          :: data(:),model(:)
    real,    dimension(:),pointer              ::tmp1

    if(adj) then
       stat=igrad2_lop(.false.,add,data,model)
    else
       stat=igrad2_lop(.true.,add,data,model)
    end if

  end function igrad2_adj_lop



end module prec_oper
