module solver_smp_jesse_3D_mod  
  ! 0 = W (F J m - d)
  use chain0_mod 
  use  solver_report_mod
!  use dipinteg_precond_3D
  use ztrans_mod
  use dipinteg_3D_2
  implicit none
  logical, parameter, private  :: T = .true., F = .false.
contains
  subroutine solver_smp_jesse3D( m,d, Fop, stepper, niter,eps_t,            Wop&
  &,Jop,m0,err,resd,mmov,rmov,verb,n1_in,n2_in,n3_in)
    optional :: Wop,Jop,m0,err,resd,mmov,rmov,verb,n1_in,n2_in,n3_in
    interface  
       !-------------------------- begin definitions -----------
       integer function Fop(adj,add,m,d)
         real::m(:),d(:)
         logical,intent(in)::adj,add
       end function Fop
       integer function Wop(adj,add,m,d)
         real::m(:),d(:)
         logical,intent(in)::adj,add
       end function Wop
       integer function Jop(adj,add,m,d)
         real::m(:),d(:)
         logical,intent(in)::adj,add
       end function Jop
       integer function stepper(forget,m,g,rr,gg)
         real, dimension(:)  ::        m,g,rr,gg    
         logical             :: forget
       end function stepper
    end interface
    real                                       ::eps_h
    real,     intent(in)                       :: eps_t
    real, dimension(:),    intent(in)          :: d, m0
    real, dimension(:),    allocatable          :: rd_orig,rd_wt
    integer,               intent(in)          :: niter,n1_in,n2_in,n3_in
    logical,               intent(in)          :: verb
    real, dimension(:),    intent(out)         :: m,err, resd
    real, dimension(:,:),  intent(out)         ::        rmov, mmov   
    real, dimension(size(m))                   :: g
    real, dimension(size(d)),         target   :: rr, gg
    real, dimension(size(d)+size(m)), target   :: tt
    real, dimension(:), pointer                :: rd, gd, td
    real, dimension(:), pointer                :: rm, gm, tm
    complex, dimension (:,:,:),   allocatable    ::ztrans
    integer                                    :: iter, stat
    logical                                    :: forget

    ! FOR BENCHMARK TIMING
    character ( len = 8 )                      :: date
    integer                                    :: h,mm,m_t,s
    character ( len = 10 )                     :: time
    integer                                    :: values(8)
    character ( len = 5 )                      :: zone

    rd => rr(1:size(d))
    gd => gg(1:size(d))
    td => tt(1:size(d))
    tm => tt(1+size(d):)
    ! eps_t=1.
    eps_h=1.
    write(0,*) 'here 2',n1_in,n2_in,n3_in
    allocate( ztrans(n1_in,2*n2_in,2*n3_in))
    allocate(rd_orig(size(d)),rd_wt(size(d)))
! rd_orig=-d  ! ASSIGN ORIGINAL DIPS TO A VARIABLE
    call z_trans(n1_in,2*n2_in,2*n3_in,eps_t,eps_h,ztrans)

    if (present( Wop)) then
       stat=Wop(F,F,-d,rd) ! begin initialization --------
    else
       rd = -d                                           !Rd = -W  d
    end if
    rd_orig=rd  ! ASSIGN ORIGINAL DIPS TO A VARIABLE
    if (present( m0)) then
       m=m0                                 !m  =     m0
       if (present( Wop)) then
          call chain0(Wop,Fop,F,T,m,rd,td)
       else
          stat =           Fop(F,T,m,rd   ) !Rd+=  WF m0
       end if
    else
       m=0
    end if
    forget = T
    !-------------------------- begin iterations ------------
    do iter = 1,niter  



       ! FOR TIMING


       call date_and_time ( date, time, zone, values )

       h = values(5)
       m_t = values(6)
       s = values(7)
       mm = values(8)

       write(0,*) m_t,s,mm


!!$       if (present(Wop)) then
!!$          call chain0(Wop,Fop,T,F,g,rd,td)
!if (iter/=1) then!$       else
!!$          stat =          Fop(T,F,g,rd   )   !g  = (WF)'Rd
!!$       end if
       !      write(0,*) 'here 3',n1_in,n2_in,n3_in  
!if (iter/=1) then
!if (real(iter)/10.-floor(real(iter/10))<.0001) then ! Gauss Newton
!write(0,*) 'rd before',maxval(rd_orig),minval(rd_orig),sum(rd_orig*rd_orig)
!write(0,*) 'nonlinear iteration', iter
!! stat=Wop(F,F,rd,rd_wt)
!!       rd=rd_wt
    
!      call correct_dip_3D  (m,rd_orig,rd,n1_in,n2_in,n3_in,1,1)
!       stat=Wop(F,F,rd,rd_wt)
!       rd=rd_wt
!write(0,*) 'rd after',maxval(rd),minval(rd),sum(rd*rd)
!end if
!!$rd_wt=0.
!!$  call chain0(Wop,Fop,F,T,m,rd_wt,td)
!!$rd=rd_orig-rd_wt
!       call dipintegrate_3D (rd,g,eps_t,eps_h,n1_in,n2_in,n3_in,ztrans) 
       !   call dipintegrate_precond_3D (rd,g,eps_t,eps_h,n1_in,n2_in,n3_in,ztrans) 
!rd=0.

  call chain0(Wop,Fop,T,F,g,rd,td)

    !   rd(1:n1_in*n2_in*n3_in)=g
!       stat=Wop(F,F,rd,rd_wt)

    !   g=rd_wt(1:n1_in*n2_in*n3_in)
       write(0,*) 'here 4'

       if (present(Jop)) then
          tm=g
          stat  = Jop(F,F,tm, g  )
       end if
       !g  =   J  g
       if (present(Wop)) then
          call chain0(Wop,Fop,F,F,g,gd,td)
       else
          stat =          Fop(F,F,g,gd   )   !Gd = (WF) g
       end if
!forget=T
       stat = stepper(forget, m,g, rr,gg)                  
       !m+=dm; R+=dR
       if (stat .eq.1) then
          exit ! got stuck descending
       end if
       if (present( mmov)) then
          mmov(:,iter) =  m(:size(mmov,1)) ! report -----
       end if
       if (present( rmov)) then
          rmov(:,iter) = rd(:size(rmov,1))
       end if
       if (present( err )) then
          err(  iter) = dot_product(rd,rd)
       end if
       if (present( verb)) then
          if (verb) then
             call solver_report(iter,m,g,rd)
          end if
       end if
       forget=F
    end do
    if (present( resd)) then
       resd = rd
    end if
  end subroutine solver_smp_jesse3D
end module solver_smp_jesse_3D_mod
